//--------------------------------------------------------------------
// (C) ESHED ROBOTEC (1982) LTD.
//
//
// Written & designed by Dimo L. Vasilenko
// Created 22.05.94
//
// CIM_DDE.CPP
// Virtual Controller Version 2.00
// DDE definitions
//--------------------------------------------------------------------

#include "stdafx.h"
//#include <windows.h>
//#include <mem.h>
//#include <string.h>

#include "cim_dde.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void* CIM_DDEModerator( void *vDDEBuffer,
			CIM_DDEMessageHeader *ddeHeader,
			const void *p,
			WORD aSizeOfData )
{
ddeHeader->wSizeOfData = aSizeOfData;
ddeHeader->lCheckSum = FrameCheckSequence( (char *)ddeHeader );
memcpy( vDDEBuffer, ddeHeader, sizeof(CIM_DDEMessageHeader) );
memcpy( (BYTE*)vDDEBuffer + sizeof(CIM_DDEMessageHeader),
			 p, aSizeOfData );
return vDDEBuffer;
}

void* CIM_DDEModerator( void *vDDEBuffer,
								CIM_DDEMessageHeader *ddeHeader )
{
ddeHeader->lCheckSum = FrameCheckSequence( (char *)ddeHeader );
memcpy( vDDEBuffer, ddeHeader, sizeof(CIM_DDEMessageHeader) );
return vDDEBuffer;
}

void* CIM_DDEGetData( void *vDDEBuffer )
{
return( (BYTE*)vDDEBuffer + sizeof( CIM_DDEMessageHeader ) );
}


CIM_DDEMessageHeader CIM_DDEExtractor( BYTE *bDDEBuffer )
{
CIM_DDEMessageHeader ddeMessageHeader;
memcpy( &ddeMessageHeader, bDDEBuffer, sizeof( ddeMessageHeader ) );
return ddeMessageHeader;
}

void* CIM_DDEAnswerer( void *vDDEBuffer )
{
CIM_DDEMessageHeader b = CIM_DDEExtractor( (BYTE*)vDDEBuffer );
CIM_DDEMessageHeader ddeHeader = CIM_DDEExtractor( (BYTE*)vDDEBuffer );
// write receiver address from sender
strcpy( (char*)ddeHeader.szNameOfWorkStation,
		  (char*)ddeHeader.szNameOfWorkStationSender );
strcpy( (char*)ddeHeader.szNameOfDDEItem,
		  (char*)ddeHeader.szNameOfDDEItemSender );
ddeHeader.wIdOfWM_ = ddeHeader.wIdOfWM_Sender;
ddeHeader.bIdOfDevice = ddeHeader.bIdOfDeviceSender;
// write home address from receiver
strcpy( (char*)ddeHeader.szNameOfWorkStationSender,
		  (char*)b.szNameOfWorkStation );
strcpy( (char*)ddeHeader.szNameOfDDEItemSender,
		  (char*)b.szNameOfDDEItem );
ddeHeader.wIdOfWM_Sender 	 = b.wIdOfWM_;
ddeHeader.bIdOfDeviceSender = b.bIdOfDevice;

return CIM_DDEModerator( vDDEBuffer, &ddeHeader );
}

//-------------------------------------------------------------------
// returns FrameCheckSequence
//-------------------------------------------------------------------
LONG FrameCheckSequence( char *ddeHeader )
{
long FCS = 0;
for( int i = 0; i < sizeof( tagCIM_DDEMessageHeader ) - 14; ++i )
	{
	FCS ^= ddeHeader[i];
	}
return FCS;
}

