//--------------------------------------------------------------------
// (C) ESHED ROBOTEC (1982) LTD.
//
//
// Written & designed by Dimo L. Vasilenko
// Created 22.05.94
//
// CIM_DDE.H
// Virtual Controller Version 2.00
// DDE definitions
//--------------------------------------------------------------------
#ifndef __CIM_DDE_H
#define __CIM_DDE_H

//------ CIM DDE Header Offsets -------------------------------------------
typedef int INT; // from <windef.h>

#define DHO_NameOfWorkStation sizeof(ddeMessageHeader.wSizeOfHeader)

#define DHO_NameOfDDEItem  DHO_NameOfWorkStation + \
				sizeof(ddeMessageHeader.szNameOfWorkStation)

#define DHO_IdOfWM_ 	   DHO_NameOfDDEItem + \
				sizeof(ddeMessageHeader.szNameOfDDEItem)

#define DHO_SizeOfData	   DHO_IdOfWM_ + \
				sizeof(ddeMessageHeader.wIdOfWM_)

#define DHO_IdOfMessage    DHO_SizeOfData + \
				sizeof(ddeMessageHeader.wSizeOfData)

#define DHO_IdOfDevice     DHO_IdOfMessage + \
				sizeof(ddeMessageHeader.lIdOfMessage)

#define DHO_bEchoFlag     DHO_IdOfDevice + \
				sizeof(ddeMessageHeader.bIdOfDevice)

#define DHO_eStatus     DHO_bEchoFlag + \
				sizeof(ddeMessageHeader.bEchoFlag)

#define DHO_NameOfWorkStationSender DHO_eStatus + \
				sizeof(ddeMessageHeader.eStatus)

#define DHO_NameOfDDEItemSender DHO_NameOfWorkStationSender + \
				sizeof(ddeMessageHeader.szNameOfWorkStationSender)

#define DHO_IdOfWM_Sender DHO_NameOfDDEItemSender + \
				sizeof(ddeMessageHeader.szNameOfDDEItemSender)

#define DHO_IdOfDeviceSender DHO_IdOfWM_Sender + \
				sizeof(ddeMessageHeader.wIdOfWM_Sender)

#define DHO_bDDEServerPass DHO_IdOfDeviceSender + \
				sizeof(ddeMessageHeader.bIdOfDeviceSender)

#define DHO_lCheckSum DHO_bDDEServerPass + \
				sizeof( ddeMessageHeader.bDDEServerPass )


#define DDE_IS_ECHO 		1
#define DDE_IS_NOECHO 	0

LONG FrameCheckSequence( char *ddeHeader );

typedef enum tagDDEMessageStatus
	{ NewOne = 0, ToBeDone, InTheWork, ToBeSent, ToBeWipe }
		DDEMessageStatus;

typedef struct tagCIM_DDEMessageHeader
{
WORD  	wSizeOfHeader;           // size of this structure
BYTE  	szNameOfWorkStation[16]; // name of Receiver WS
BYTE  	szNameOfDDEItem[16];     // name of Receiver  DDE Item
WORD 		wIdOfWM_;                // WM_ of this data for Receiver
WORD 		wSizeOfData;             // size of Data
LONG 		lIdOfMessage;            // the sequence number of message
BYTE  	bIdOfDevice;             // ID of phisical device Receiver
BYTE     bEchoFlag;					 // 0 - noecho, 1 - echo
INT      eStatus;                 // DDEMessageStatus

BYTE  	szNameOfWorkStationSender[16]; // name of Sender WS
BYTE  	szNameOfDDEItemSender[16];     // name of Sender  DDE Item
WORD 		wIdOfWM_Sender;                // WM_ of this data for Sender
BYTE  	bIdOfDeviceSender;       // ID of phisical device Sender

BYTE		bDDEServerPass;          // Flag to indicate the message :
											 // to be passed through the DDE
											 // Server = 1
											 // is for the DDE Server = 0
LONG 		lCheckSum;
BYTE		bReserved[10];

tagCIM_DDEMessageHeader(
				BYTE *aNameOfWorkStation,
				BYTE *aNameOfDDEItem,
				WORD aIdOfWM_,
				WORD aSizeOfData,
				LONG aIdOfMessage,
				BYTE aIdOfDevice,
				BYTE aEchoFlag,
				INT  aStatus,
				BYTE *aNameOfWorkStationSender,
				BYTE *aNameOfDDEItemSender,
				WORD aIdOfWM_Sender,
				BYTE aIdOfDeviceSender,
				BYTE aDDEServerPass,
				LONG aCheckSum
				)
	{
	wSizeOfHeader = sizeof( tagCIM_DDEMessageHeader );
	strcpy( (char*)szNameOfWorkStation, (char*)aNameOfWorkStation );
	strcpy( (char*)szNameOfDDEItem, (char*)aNameOfDDEItem );
	wIdOfWM_ = aIdOfWM_;
	wSizeOfData  = aSizeOfData;
	lIdOfMessage = aIdOfMessage;
	bIdOfDevice  = aIdOfDevice;
	bEchoFlag    = aEchoFlag;
	eStatus		 = aStatus;
	strcpy( (char*)szNameOfWorkStationSender, (char*)aNameOfWorkStationSender );
	strcpy( (char*)szNameOfDDEItemSender, (char*)aNameOfDDEItemSender);
	wIdOfWM_Sender = aIdOfWM_Sender ;
	bIdOfDeviceSender = aIdOfDeviceSender ;
	bDDEServerPass = aDDEServerPass;
	lCheckSum = aCheckSum;
	}

tagCIM_DDEMessageHeader()
	{
	wSizeOfHeader = sizeof( tagCIM_DDEMessageHeader );
	szNameOfWorkStation[0] = '\0';
	szNameOfDDEItem[0] = '\0';
	wIdOfWM_ = 0;
	wSizeOfData  = 0;
	lIdOfMessage = 0;
	bIdOfDevice  = 0;
	bEchoFlag    = 0;
	eStatus		 = NewOne;
	szNameOfWorkStationSender[0] = '\0';
	szNameOfDDEItemSender[0] = '\0';
	wIdOfWM_Sender = 0;
	bIdOfDeviceSender = 0;
	bDDEServerPass = 1;
	lCheckSum = 0;
	lCheckSum = 0;
	}

} CIM_DDEMessageHeader;


void*   CIM_DDEModerator( void *vDDEBuffer,
			CIM_DDEMessageHeader *ddeHeader,
			const void *p,
			WORD aSizeOfData );

void*    CIM_DDEModerator( void *vDDEBuffer,
			CIM_DDEMessageHeader *ddeHeader );

void*    CIM_DDEGetData( void *vDDEBuffer );

CIM_DDEMessageHeader    CIM_DDEExtractor( BYTE *bDDEBuffer );
void*    CIM_DDEAnswerer( void *vDDEBuffer );


// List of New-Technology-Windows-DDE-For-CIM Messages
#define WM_CIMDDE_FIRST   		WM_USER + 1000
#define WM_CIMDDE_DEBUG1  		WM_USER + 1001  // debug 1
#define WM_CIMDDE_DEBUG2  		WM_USER + 1002  // debug 1
#define WM_CIMDDE_DEBUG3  		WM_USER + 1003  // debug 1
#define WM_CIMDDE_RTB  			WM_USER + 1004  // Responce table builder
#define WM_CIMDDE_RTA  			WM_USER + 1005  // Responce table Item add
#define WM_CIMDDE_RTD  			WM_USER + 1006  // Responce table Item del
#define WM_CIMDDE_CWHAS    	WM_USER + 1007  // Client Write Header and Send
#define WM_CIMDDE_SWHAS    	WM_USER + 1007  // Server Write Header and Send
#define WM_CIMDDE_ACLDRV   	WM_USER + 1008  // ACL Runner
#define WM_CIMDDE_ACLCOMMAND	WM_USER + 1009  // ACL Command
#define WM_CIMDDE_ACLMOVE		WM_USER + 1010  // Move for OLMT

#define WM_CIMDDE_ACLSTART   		WM_USER + 1201
#define WM_CIMDDE_ACLFINISH   	WM_USER + 1202
#define WM_CIMDDE_ACLUSER 		   WM_USER + 1203
#define WM_CIMDDE_ACLREADY 	   WM_USER + 1204
#define WM_CIMDDE_ACLERROR 	   WM_USER + 1205
#define WM_CIMDDE_ACLEND 			WM_USER + 1206

#define WM_CIMDDE_PLCINIT     	WM_USER + 1300
#define WM_CIMDDE_INIT     		WM_USER + 1300
#define WM_CIMDDE_INITEND        WM_USER + 1333
#define WM_CIMDDE_DEVICEISREADY  WM_USER + 1334

#define WM_CIMDDE_DEVICEISOFF  	WM_USER + 1335

#define WM_CIMDDE_PLCDELIVER     WM_USER + 1301
#define WM_CIMDDE_PLCRELEASE     WM_USER + 1302
#define WM_CIMDDE_PLCCLEARERROR  WM_USER + 1303
#define WM_CIMDDE_PLCSETERROR    WM_USER + 1304
#define WM_CIMDDE_PLCFREE    		WM_USER + 1305
#define WM_CIMDDE_PLCGETFREE    	WM_USER + 1306
#define WM_CIMDDE_PLCRESERV    	WM_USER + 1307

#define WM_CIMDDE_PLCSTOP        WM_USER + 1311
#define WM_CIMDDE_PLCPASS        WM_USER + 1312
#define WM_CIMDDE_PLCERROR       WM_USER + 1313
#define WM_CIMDDE_PLCARRIVEFREE  WM_USER + 1314
#define WM_CIMDDE_PLCCOMPLEX  	WM_USER + 1315

#define WM_CIMDDE_OLMTCLOSE		WM_USER + 1230
#define WM_CIMDDE_OLMTOPEN		WM_USER + 1231

#define WM_CIMDDE_ASRSCLOSE		WM_USER + 1400
#define WM_CIMDDE_ASRSOPEN		WM_USER + 1401
#define WM_CIMDDE_ASRSCHANGE		WM_USER + 1402


#define WM_CIMDDE_OLMTCREATE		WM_USER + 1220
#define WM_CIMDDE_OLMTDELETE		WM_USER + 1221
#define WM_CIMDDE_OLMTCONNECT		WM_USER + 1222

#define WM_CIMDDE_CNCREQUEST		WM_USER + 1550
#define WM_CIMDDE_CNCRETURN		WM_USER + 1551
#define WM_CIMDDE_CNCERROR			WM_USER + 1552
#define WM_CIMDDE_CNCIGNORE		WM_USER + 1553
#define WM_CIMDDE_CNCRETRY			WM_USER + 1554
#define WM_CIMDDE_CNCFAIL			WM_USER + 1555
#define WM_CIMDDE_CNCSPECEND		WM_USER + 1556
#define WM_CIMDDE_CNCSTART			WM_USER + 1557
#define WM_CIMDDE_CNCFINISH		WM_USER + 1558
#define WM_CIMDDE_CNCTASKLOADED	WM_USER + 1559
#define WM_CIMDDE_CNCLOADTASK	   WM_USER + 1560


#define WM_CIMDDE_SRVCCLOSE		WM_USER + 1350
#define WM_CIMDDE_SRVCOPEN			WM_USER + 1351
#define WM_CIMDDE_SRVCECHO			WM_USER + 1352
#define WM_CIMDDE_SRVCNOECHO 		WM_USER + 1353
#define WM_CIMDDE_SRVCGSTAT		WM_USER + 1354
#define WM_CIMDDE_SRVDELMSG		WM_USER + 1355
#define WM_CIMDDE_SRVCSTAT 		WM_USER + 1356
#define WM_CIMDDE_SRVCNRSP			WM_USER + 1357
#define WM_CIMDDE_ISVC2READY     WM_USER + 1358  // added 16.08.94
#define WM_CIMDDE_VC2ISREADY     WM_USER + 1359  // added 16.08.94


#define WM_CIMDDE_ABORT				WM_USER + 1099

#define WM_CIMDDE_CLOSEDEVICE		WM_USER + 1100
#define WM_CIMDDE_CLOSEDEVICES   WM_USER + 1101
#define WM_CIMDDE_CLOSESTATION   WM_USER + 1102
#define WM_CIMDDE_CLOSEALL       WM_USER + 1103
#define WM_CIMDDE_NETSDOWN       WM_USER + 1104
#define WM_CIMDDE_NETCDOWN       WM_USER + 1105
#define WM_CIMDDE_NETLISTEN      WM_USER + 1106
#define WM_CIMDDE_NETSNOCALL     WM_USER + 1107
#define WM_CIMDDE_NETCREMOVE     WM_USER + 1108
#define WM_CIMDDE_EMDEVICE       WM_USER + 1109
#define WM_CIMDDE_EMDEVICES      WM_USER + 1110
#define WM_CIMDDE_EMSTATION      WM_USER + 1111
#define WM_CIMDDE_NETEMERGENCY   WM_USER + 1112

#define WM_CIMDDE_SENDSTRING     WM_USER + 1113
#define WM_CIMDDE_SENDSTRINGCNCTORUN	WM_USER + 1114

#define WM_CIMDDE_BADWSNAME   	WM_USER + 1115


#define WM_CIMDDE_SETSMPHRGREEN  WM_USER + 1120

#define WM_CIMDDE_RVPSCAN        WM_USER + 1150
#define WM_CIMDDE_RVPOBJSCANED   WM_USER + 1151

#define WM_CIMDDE_LSMSCAN        WM_USER + 1160
#define WM_CIMDDE_LSMSCANED      WM_USER + 1161

#define WM_CIMDDE_QCREQUEST      WM_USER + 1170
#define WM_CIMDDE_QCRESULT       WM_USER + 1171

#define WM_CIMDDE_MAILSLOTRAWPOST WM_USER + 1200


#define DDE_RETRY_INTERVAL			10 // wait and send again (sec)
#define MAX_DDE_ITEMSNUM			10
#define MAX_DDE_DATABUFFER 		512
#define MAX_DDE_SEQUENCE_MSGN 	4000000000L

#define VC2_DDE_SERVICE 		"vc2_dde_service"
#define VC2_DDE_TOPIC  			"vc2_dde_topic"


#define WM_NDDE_CONNECT          WM_USER + 3000
#define WM_NDDE_POSTADVISE       WM_USER + 3001
#define WM_NDDE_DISCONNECT       WM_USER + 3002

#define MAX_CIMDDEHISTORY        20

#define DDE_CHANNELSMADE	8

#define DDE_CIMITEM			"dde_cim"
#define DDE_CIM        			0
#define DDE_OLMTITEM		"dde_olmt"
#define DDE_OLMT       			1
#define DDE_ACLITEM			"dde_acl"
#define DDE_ACL       			2
#define DDE_PLCITEM			"dde_plc"
#define DDE_PLC       			3
#define DDE_CNCITEM			"dde_cnc"
#define DDE_CNC       			4
#define DDE_RVPITEM			"dde_rvp"
#define DDE_RVP       			5
#define DDE_LSMITEM			"dde_lsm"
#define DDE_LSM       			6
#define DDE_ASRSITEM		"dde_asrs"
#define DDE_ASRS       			7






#define  DYNAMICDATAEXCHANGE  	"DynamicDataExchange"
#define 	DDESERVERTIMEINTRL		"DDEServerTimeIntrl"
#define 	DDEACLDRIVERTIMEINTRL   "DDEACLDriverTimeIntrl"
#define 	DDEPLCDRIVERTIMEINTRL   "DDEPLCDriverTimeIntrl"
#define 	DDERVPDRIVERTIMEINTRL   "DDERVPDriverTimeIntrl"
#define 	DDECNCDRIVERTIMEINTRL   "DDECNCDriverTimeIntrl"
#define 	DDELSMDRIVERTIMEINTRL   "DDELSMDriverTimeIntrl"

#define 	DDESERVERTIMEOUT        "DDEServerTimeOut"
#define 	DDEACLDRIVERTIMEOUT   	"DDEACLDriverTimeOut"
#define 	DDEPLCDRIVERTIMEOUT   	"DDEPLCDriverTimeOut"
#define 	DDERVPDRIVERTIMEOUT   	"DDERVPDriverTimeOut"
#define 	DDECNCDRIVERTIMEOUT   	"DDECNCDriverTimeOut"
#define 	DDELSMDRIVERTIMEOUT   	"DDELSMDriverTimeOut"

#define FN_WSDDERESPONSE   		"VC2_WM.DBF"


#endif  // #define CIM_DDE_H

