// File: mTie.cpp                              Date: 15-NOV-2004
//

#include "..\\stdafx.h"
// #include "..\\scorbase.h"


#include "mTie.h"
#include "..\\DataBase\\d4all.hpp"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CmTie

// #include <fstream.h> 

const UINT cuiTimerID = 55;
const UINT cuiNormalInterval = 300;
const UINT cuiNoConnectInterval = 3000;

//Debug function
// #define SOCKETDEBUG 1

void CmTie::ClearDebugFile(){
#ifdef SOCKETDEBUG	
	char mPath[MAXPATH];
	::ofstream  sFile;

	strcpy(mPath,(LPSTR)(LPCTSTR)GetPath(GetIniFilePath()));
	strcat(mPath,"\\AGVSocketDebug.log");

	sFile.open(mPath,ios::out);   
	sFile.close();
#endif
}

void CmTie::toDebugFile(LPSTR str,LPSTR mName,WORD mID, int mNumber){
#ifdef SOCKETDEBUG	
	::ofstream  sFile;
  //char temp[82];
	CTime t=CTime::GetCurrentTime();
	char sTime[16];
	char mPath[MAXPATH];


  strcpy(mPath,(LPSTR)(LPCTSTR)GetPath(GetIniFilePath()));
	strcat(mPath,"\\AGVSocketDebug.log");

	sprintf( sTime, " (%02d:%02d:%02d)",t.GetHour(), t.GetMinute(), t.GetSecond());
	sFile.open(mPath,ios::app);   
	

	sFile <<sTime<<"  "<<str<<"  "<<mName<<"  "<<mID<<"  ("<<mNumber<<")";

	sFile << endl;
   
	sFile.close();
#endif
}
////////////////////////////////////////////




CmTie::CmTie(){
	tempserver0=NULL;
	KnotName="";
	KnotIp="";
	KnotCode="";
	KnotIndex=0;
  KnotMainChannel=0;
	m_ErrorMessageCount=0;
	m_seqSendMSGNumber=0;
	CurrentSenderID=0;
	CurrentReceive="";
}

CmTie::~CmTie(){

	if(tempserver0){
		delete tempserver0; 
		tempserver0=NULL;
	}

	if( m_hWnd )
	   KillTimer(55);

}



BOOL CmTie::Create(CWnd* mParent, LPSTR mName, int mIndex, HWND mHW)
{
  CRect      mRect(0,0,0,0);
  char       mServerIP[16];

	strcpy(mServerIP,"");
	strcpy(mServerIP,GetLocalIPAddress(mServerIP, mServerIP));
  InitializeKnot(mServerIP,mName, mIndex);
  m_SendHWND=mHW;


  return CWnd::Create(NULL,"CKnotManager", WS_OVERLAPPEDWINDOW|WS_CHILD|
    							WS_DISABLED, mRect, mParent, 3333);
}

bool CmTie::InitializeKnot(	CString mIP, CString name,int mIndex)
{
  
  CString tempStr;
//  char szBuf[30];    Error in KnotName=szBuf; line
  static char szBuf[30];    // Shimon       

  char szWork[256];
	if(mIndex!=0)
	   sprintf(szBuf,"%s%d",name, mIndex);
	else
		strcpy(szBuf,name);

	if(name!="")
	{
		KnotName=szBuf;
	  KnotCode=name;
		KnotIndex=mIndex;
	}
  else
  {    

	strcpy( szWork, "(4) Invalid knot name");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("InvalidKnotName"), szWork, sizeof szWork);
    AfxMessageBox(szWork);
		return false;
  }

	if(mIP!="")
    KnotIp=mIP;
  else
  {
        strcpy( szWork, "(5) Invalid IP address");       
//	    e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("InvalidIPAddress"), szWork, sizeof szWork);
		AfxMessageBox(szWork);		
		return false;
  }

  InitMessageStruct();
	return true;
}



//ON_MESSAGE( WM_SENDTOCONNECT, SendToConnect)
BEGIN_MESSAGE_MAP(CmTie, CWnd)
  
	//{{AFX_MSG_MAP(CmTie)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CmTie message handlers

long CmTie::GetIdFromName(LPSTR mName){
  long result;
	result=0;
  char tempS[80]; 

  int index=0;
	int len=strlen(mName);
  while(index<len){
		if(mName[index]>=48 && mName[index]<=57){
       strcpy(tempS,mName+index);
			 index=len;
		}
		index++;
	}

  result=atol(tempS); 	
	return result;
}



CString CmTie::GetPath(CString str){
  int index;
	
  CString temp=str;
  
	temp.MakeUpper();
	index=temp.Find("MAP.INI");
	if (index!=0)
		return temp=temp.Mid(0,index-1);
	else
		return str;
}



/*
BOOL CmTie::CreateAdditionalServer(UINT channel){


  CmServer* tempserver=new CmServer(this);

	if(!tempserver->Create(channel,SOCK_STREAM,KnotIp)){
		//"Not createded server of knot."		 
    AfxMessageBox(GetErrorMessage(5));
		return FALSE;    
	}

	if(!tempserver->Listen()){
		//"Not createded server of knot."		 
    AfxMessageBox(GetErrorMessage(5));
		return FALSE;
	}
	return TRUE;
}
*/


void CmTie::CreateAlias(UINT channel,LPSTR mAlias){
	CSendStructure tempSend;
	tempSend.mCheckSum=0;
	tempSend.mIDWM=0;
	tempSend.mOrderNumber=1;
	tempSend.SenderChannel=KnotMainChannel;
  strcpy(tempSend.SenderIP,(LPSTR)(LPCTSTR)KnotIp);
	strcpy(tempSend.SenderName,mAlias);
	FillIniFile(&tempSend);
}



BOOL CmTie::CreateMainServer(UINT channel, BOOL HowIAm){
  //CmServer* tempserver=new CmServer(this);


	tempserver0=new CmServer(this);
	ImManager=HowIAm;


	ClearDebugFile();
	FillDBInfo();
	if(!tempserver0->Create(channel,SOCK_STREAM,KnotIp)){
		//"Not createded server of knot."		 
    AfxMessageBox(GetErrorMessage(5));
		return FALSE;    
	}

	if(!tempserver0->Listen()){
		//"Not createded server of knot."		 
    AfxMessageBox(GetErrorMessage(5));
		return FALSE;
	}

	KnotMainChannel=channel;

	CSendStructure tempSend;
	tempSend.mCheckSum=0;
	tempSend.mIDWM=0;
	tempSend.mOrderNumber=1;
	tempSend.SenderChannel=channel;
  strcpy(tempSend.SenderIP,(LPSTR)(LPCTSTR)KnotIp);
	strcpy(tempSend.SenderName,(LPSTR)(LPCTSTR)KnotName);
	FillIniFile(&tempSend);
	cuiCurrentInterval = cuiNormalInterval;
	SetTimer(cuiTimerID,cuiCurrentInterval,NULL);


  return TRUE;
}




void CmTie::ProcessPendingRead(CmServer* pSocket,
															 CSendStructure& temps,
															 NDDEDataToBePassed* mData,
															 int mType){
  ReadMsg(pSocket,temps,mData, mType);
	CloseSocket(pSocket);
}




bool CmTie::ReadMsg(CmServer* pSocket,
                    CSendStructure& temps,
										NDDEDataToBePassed *mData,
										int mType)
{

  bool status;

  char* tempD2=(char*)mData->vPOfData;

	//555 TRY{		 


   toDebugFile("New Message","----",0,0);

    //Send executable message
    long tempDeviceId;
		tempDeviceId=GetIdFromName(temps.SenderName);
    ::SendMessage(m_SendHWND,WM_UPDATEDEVSTATUS,tempDeviceId,1);


		char tempParam[60];    
		CString tempSender;
		CString tempStrN;
		tempSender=CString(temps.SenderName);
		strcpy(tempParam,"To Manager");

		    
    if(tempSender.Find("PLC")==-1)
			::SendMessage(m_SendHWND,WM_WRITEMESSAGE,(long)(LPSTR)(LPCTSTR)tempSender,(long)&tempParam);
  			
		 //if m_SendHWnd not exist, then not send message and
    tempStrN=KnotName+CString(" Get from: "); 
		toDebugFile((LPSTR)(LPCTSTR)tempStrN,(LPSTR)(LPCTSTR)tempSender,mData->wWM_OfMine, temps.mOrderNumber);
  
		if(PauseStatus==TRUE){
		  if(mData->wWM_OfMine==0){        
//        ::SendMessage(m_SendHWND,WM_CIM_DRAWLINE,tempDeviceId,(long)(char*)&mData->vPOfData);        
				::SendMessage(m_SendHWND,temps.mIDWM,tempDeviceId,(long)(void*)&mData->vPOfData);
			}
		  else{
//				::SendMessage(m_SendHWND,WM_CIM_DRAWLINE,tempDeviceId,(long)(char*)&mData->vPOfData);				
        ::SendMessage(m_SendHWND,temps.mIDWM,tempDeviceId,(long)(void*)mData);
			}
		}

	//	FillIniFile(&temps,mType);

/*MMR 555
		switch (IsInINIFile(&temps)){
			case 0: //new
				FillIniFile(&temps, mType); 
				break;
			case 1:
        // details already exist in the iniFile
				break;
			case 2://change
				FillIniFile(&temps,mType);
				break;
		}
*/

		status=true;
/*555
	}
	CATCH(CFileException, e){
		CString strTemp;				
		::MessageBox(NULL,
			           (LPSTR)(LPCTSTR)(GetErrorMessage(7)),
								 "Communication Error",MB_OK|MB_ICONEXCLAMATION);
		status=false;
	}
	END_CATCH
*/	
	return status;
}


void CmTie::CloseSocket(CmServer* pSocket){
	pSocket->Close();
	delete pSocket;
}


void CmTie:: SetPauseStatus(BOOL mstatus){
  PauseStatus=mstatus;
}

void CmTie::SendErrorMessage(CString str,long AddParam){	
  ::SendMessage(m_SendHWND,WM_DRAWERRORMESSAGE,AddParam,(LPARAM)(LPSTR)(LPCTSTR)str);
}



void CmTie::FillDBInfo(){
  CString DataPath;
  DataPath=GetPath(m_iniFilePath);
	DataPath=DataPath+CString("\\..\\vc2_wm.dbf");
  Code4 cb;
	 
	if(cb.errorCode){
		return;
    //cb.exit();
	}

  Data4 data(cb,DataPath);  

	cb.singleOpen=0;
	Field4 m_input(data,2); 
	Field4 m_output(data,5);

  data.top();
	CPointMess tempPoint;

  for(long il=1L;il<=data.recCount();il++){
    data.go(il); 
		tempPoint.mInput=(int)m_input;
		tempPoint.mOutput=(int)m_output;
		m_MessPoints.AddTail(tempPoint);
  }

	data.close();
	cb.initUndo();
}




BOOL CmTie::VBSendMsg(CSendQueue& CurrentMsg ,CmServer* tempserver){

	CString mSend;
	NDDEDataToBePassed* tempPass=(NDDEDataToBePassed*)CurrentMsg.mDataToPass; 			
	BOOL tempStatus=false;
	CString m_strText;
		
						
	mSend = "";
	// /cs - check sum
	mSend = mSend + "/cs 0";
	// /on - order number - it is option
  m_strText.Format("%d",m_seqSendMSGNumber);//GetOrderNumber(mPort));
	mSend = mSend + "/on "+m_strText;
	// /sch - sender channel
	m_strText.Format("%d",KnotMainChannel);
	mSend = mSend + "/sch " + m_strText;
	// /sip - sender IP address
	mSend = mSend + "/sip " + KnotIp;
	// /sname - sender name
	mSend = mSend + "/sname " + KnotName;


	POSITION pos;
	pos=m_MessPoints.GetHeadPosition();
	CPointMess tempP;


	WORD TempmIDWM=tempPass->wWM_OfMine;
	while(pos){
		tempP=m_MessPoints.GetNext(pos);
		if(tempP.mInput==tempPass->wWM_OfMine){
			TempmIDWM=tempP.mOutput;
			break;
		}
	}
	// /idwm - Windows Message ID
  m_strText.Format("%d",TempmIDWM);
	mSend = mSend + "/idwm " + m_strText;

	switch(TempmIDWM){
		case 2574:  //CNC send DDE  (program /prog and parameter /prm)
			CNCStruct *CNCData1;
			CNCData1=(CNCStruct*)tempPass->vPOfData;
			mSend = mSend + CString("/mess /tn ") + 
				    CString(CNCData1->szRequest)
						+CString(",")+CString("/prog ")+GetSubString(CString(CNCData1->szArgv),",",1)+
						CString("/prm ")+GetSubString(CString(CNCData1->szArgv),",",2);					

			break;
		case 2584:  //CNC task load  (file /fn and where /ln - ?)
			CNCStruct *CNCData2;
			CNCData2=(CNCStruct*)tempPass->vPOfData;
			mSend = mSend + "/mess /tn " + 
				    CString(CNCData2->szRequest)
						+CString(",")+CString("/fn ")+GetSubString(CString(CNCData2->szArgv),",",1)+
						CString("/ln ")+GetSubString(CString(CNCData2->szArgv),",",2);					
						
			break;
		case 2194:  //Vision
			CimQCStructSoc *QcData;
			QcData=(CimQCStructSoc*)tempPass->vPOfData;
			mSend = mSend + "/mess /prog "+ CString(QcData->szRequest);
			break;
		default:
			m_strText=(char*)tempPass->vPOfData;
			mSend = mSend + "/mess " + m_strText;
			mSend = mSend + "&";
			break;

	}


	mSend = mSend + "/";

	if(tempserver->Send((void*)(LPSTR)(LPCTSTR)mSend,
	           mSend.GetLength())){
		//m_seqSendMSGNumber++;
		tempStatus=TRUE;
		::SendMessage(m_SendHWND,WM_UPDATEDEVSTATUS,CurrentSenderID,1);
	}
	else
		::SendMessage(m_SendHWND,WM_UPDATEDEVSTATUS,CurrentSenderID,0);

	return tempStatus;
}



BOOL CmTie::VCSendMsg(CSendQueue& CurrentMsg,CmServer* tempserver){

	CSendStructure tempStr;//=(CSendStructure*) strMess;
	BYTE    vDDEBuffer[1024];	
	BOOL tempStatus=false;

	
	NDDEDataToBePassed* tempPass=(NDDEDataToBePassed*)CurrentMsg.mDataToPass; 


	//tempStr.mOrderNumber=GetOrderNumber(mPort);
	tempStr.mOrderNumber=m_seqSendMSGNumber;
	tempStr.mCheckSum=0;
	tempStr.SenderChannel=KnotMainChannel;
	strcpy(tempStr.SenderName,KnotName);
	strcpy(tempStr.SenderIP,KnotIp);
	POSITION pos;
	pos=m_MessPoints.GetHeadPosition();
	CPointMess tempP;

	tempStr.mIDWM=tempPass->wWM_OfMine;
	while(pos){
		tempP=m_MessPoints.GetNext(pos);
		if(tempP.mInput==tempPass->wWM_OfMine){
      tempStr.mIDWM=tempP.mOutput;
			break;
		}
	}

	memcpy( vDDEBuffer, &tempStr, sizeof(CSendStructure) );
	memcpy( (BYTE*)vDDEBuffer + sizeof(CSendStructure),
	        CurrentMsg.mDataToPass, CurrentMsg.mSize);

	//NDDEDataToBePassed* tempdata=(NDDEDataToBePassed*)mDataToPass;
	CString tempStrN;
	tempStrN=KnotName+CString(" Send to: "); 
	toDebugFile((LPSTR)(LPCTSTR)tempStrN,(LPSTR)(LPCTSTR)CurrentReceive,tempStr.mIDWM,m_seqSendMSGNumber);

	if(tempserver->SendMsg((void*)&vDDEBuffer,
	           sizeof(CSendStructure)+
						 CurrentMsg.mSize)){
	 //m_seqSendMSGNumber++;
	 tempStatus=TRUE;
	}

	return tempStatus;
}


BOOL CmTie::SendMsg(UINT mPort, CString& ToIp, 
										void* mDataToPass,WORD mSize,
										int mType){

	CSendQueue tempQueue;

	m_seqSendMSGNumber++;

	memcpy(tempQueue.mDataToPass,mDataToPass,mSize);
	tempQueue.mNumber=m_seqSendMSGNumber;
	tempQueue.mPort=mPort;
	tempQueue.mSize=mSize;
	tempQueue.mType=mType;
	tempQueue.ToIp=ToIp;
	tempQueue.mName=CurrentReceive;


  m_SendQueue.AddTail(tempQueue);	

  return TRUE;
}



BOOL CmTie::SendMsgFromQueue(){
  
	BOOL					tempStatus=false;
	CmServer			*tempserver;
//	char					tempS[90];	
	POSITION			pos;
  CSendQueue		tempQueue;


	pos=m_SendQueue.GetHeadPosition();

	if(pos){
		tempQueue=m_SendQueue.GetHead();
		tempserver=new CmServer(this);


		CurrentReceive=tempQueue.mName;
		//strcpy(tempS,"From Manager");	
		//::SendMessage(m_SendHWND,WM_WRITEMESSAGE,(long)(LPSTR)(LPCTSTR)CurrentReceive,(long)&tempS);
		
		 
//		sprintf(tempS,"Preparation send to:%s %d",tempQueue.ToIp,tempQueue.mPort);
//		SendErrorMessage(tempS,1);	
	

		if(tempserver->ConnectSocket(tempQueue.mPort,(LPSTR)(LPCTSTR)tempQueue.ToIp)){		
			if(tempQueue.mType==2){
				tempStatus=VBSendMsg(tempQueue,tempserver);
			}
			else{
				tempStatus=VCSendMsg(tempQueue,tempserver);
			}
		}
  
		delete tempserver;
		tempserver=NULL;
	}
  
	
	return tempStatus;
}





BOOL CmTie::IsInList(LPSTR Receivername, CString &ToIp, UINT &mPort){
  POSITION			pos;
	CTCPIPData		tempT;

	pos=m_TCPIPData.GetHeadPosition();

	while(pos){
    tempT=m_TCPIPData.GetNext(pos);
		if(strcmp(tempT.TargetName,Receivername)==0){
			ToIp=tempT.ToIp; 
			mPort=tempT.mPort;
			return TRUE;
		}
	}

	return FALSE;
}


BOOL CmTie::SendMsg(LPSTR Receivername, 
													 void* strText,
													 WORD  mSize,
													 WORD  MesID){  
	CString             ToIp;
	UINT                mPort;   
	char								temp[4];
	char								tempS[30];
	char								section[30];
	int									mType;
	CTCPIPData					tempT;

	CurrentReceive=CString(Receivername);


  if(IsInList(Receivername,ToIp,mPort)==TRUE){ //MMR 17/08/2000

	}
	else{
		CurrentSenderID=GetIdFromName(Receivername);
		ToIp=GetToIp(Receivername);    	 
		mPort=GetToPort(Receivername);
		//MMR 17/08/2000
		tempT.mPort=mPort;
		tempT.ToIp=ToIp;
		tempT.TargetName=Receivername;
		
		m_TCPIPData.AddTail(tempT);
		
	}


	//read type
	strcpy(tempS,Receivername);  
	strcpy(section,COMMEXTENSION);
	strncat(section,tempS,25);
	section[strlen(section)+1]='\0';


  GetPrivateProfileString(section, 
													"RemoteType","", 
													temp,3,
													m_iniFilePath);
	mType=0;
	
	if(strncmp(temp,"VB",2)==0)
		mType=2;


	if(ToIp=="" || mPort<=0 || mPort>10000)
		return FALSE;
	else
		return SendMsg(mPort, ToIp, (void*)strText, mSize, mType);  
}


//Get from system
LPCTSTR CmTie::GetLocalIPAddress(LPSTR mIPAddress, 
																				LPSTR HostName){
             
 struct hostent*   Host;
 SOCKADDR_IN       Address;
 unsigned char     symbol; 
 char              temp[3];
 

 if(strcmp(HostName,"")==0){
   gethostname(HostName,30);
 }


 memset(&Address,0,sizeof(Address));

 Host=gethostbyname(HostName);
 if(Host!=NULL) {
   Address.sin_family=AF_INET;
	 //Address.sin_port=htons(()Port);
	 memcpy(&Address.sin_addr,Host->h_addr_list[0],Host->h_length);
	 symbol=Address.sin_addr.S_un.S_un_b.s_b1;
	 itoa(symbol,temp,10);
	 strcpy(mIPAddress,temp);
	 strcat(mIPAddress,".");
	 symbol=Address.sin_addr.S_un.S_un_b.s_b2;
	 itoa(symbol,temp,10);
	 strcat(mIPAddress,temp);
	 strcat(mIPAddress,".");
	 symbol=Address.sin_addr.S_un.S_un_b.s_b3;
	 itoa(symbol,temp,10);
	 strcat(mIPAddress,temp);
	 strcat(mIPAddress,".");
	 symbol=Address.sin_addr.S_un.S_un_b.s_b4;
	 itoa(symbol,temp,10);
	 strcat(mIPAddress,temp);
 }
  
 

 return mIPAddress;
}


//float& CmTie::CheckInterval(){
//  return m_checkInterval;//
//}

CString& CmTie::IniFilePath(){
  return m_iniFilePath;
}


void CmTie::FillIniFile(CSendStructure* str, int mType)
{
	char      temp[30];
	char      tempS[30];
  long      tempP;
  char      section[30];

  //read name
	strcpy(tempS,str->SenderName);  
  strcpy(section,COMMEXTENSION);
	strncat(section,tempS,25);
	section[strlen(section)+1]='\0';

  //read port
  tempP=str->SenderChannel;
  ltoa(tempP,tempS,10);

  //read IP address
  strcpy(temp,str->SenderIP);  	

  WritePrivateProfileString (section, 
		                         "RemoteIP", 
														 temp,
														 m_iniFilePath);

  WritePrivateProfileString (section, 
		                         "RemotePort", 
														 tempS,
														 m_iniFilePath);
	if(mType==2)
		  WritePrivateProfileString (section, 
		                         "RemoteType", 
														 "VB",
														 m_iniFilePath);

}



int CmTie::IsInINIFile(CSendStructure* tempSS){
	char temp[30];
	char tempS[30];
  long tempP;
  int  flag;
	
	strcpy(tempS,(char*)tempSS->SenderName);
  strncpy(temp,GetToIp(tempS),29);
  temp[strlen(temp)+1]='\0';

  tempP=GetToPort(tempS);
 

	flag=0; 
  if(strcmp(temp,"")==0) 
    return 0;

  if(strcmp(temp,tempSS->SenderIP)==0)
    flag=1;
  else
		flag=2;


  if(tempP==tempSS->SenderChannel)
		flag=1;
	else
		flag=2;

	
  if (flag==2){		
    CString tempMess;
		CString tempStr;
		
    
		tempMess=CString("Do you want change communication properties\n");
		tempStr.Format("%d",tempP);
		tempMess=tempMess+CString("    from: (")+CString(temp)+CString(" ")+tempStr+CString(")\n");
    tempStr.Format("%d",tempSS->SenderChannel);
		tempMess=tempMess+CString("    to: (")+tempSS->SenderIP+" "+tempStr+")";

		if(::MessageBox(NULL,(LPSTR)(LPCTSTR)tempMess,
					               "Communication Error", MB_YESNO)!=IDYES)
				flag=0;
			
	}

	return flag;	
}



//tempS - name of the device 
CString CmTie::GetToIp(LPSTR tempS)
{
	char temp[17];
  char section[30]; 

  strcpy(section,COMMEXTENSION);
	strncat(section,tempS,25);
	section[strlen(section)+1]='\0';

	if (GetPrivateProfileString ( section, "RemoteIP","",temp,16, m_iniFilePath))
	{
		temp[16]='\0';
		return CString(temp);

	}
	else
	  return "";
}

//tempS - name of the device 
long CmTie::GetToPort(LPSTR tempS)
{
  char section[30]; 
  long result;

  strcpy(section,COMMEXTENSION);
	strncat(section,tempS,25);
	section[strlen(section)+1]='\0';

	result=0L;
	result=(long)GetPrivateProfileInt( section, "RemotePort",0,
														m_iniFilePath);		

  return result;
}


CString  CmTie::GetErrorMessage(int index){
  if(index<=m_ErrorMessageCount)
    return m_MSGStruct[index].Message;
	
	return "";
}

CString  CmTie::GetErrorMessage(int index, CString text){
  if(index<=m_ErrorMessageCount){
		CString temp;
    int position;

    temp=m_MSGStruct[index].Message;
    position=temp.Find("$",1);
		if(position>0){
			temp.Delete(position,1); 
      temp.Insert(position,text);
		}
    return temp;
	}
	return "";
}



int CmTie::GetOrderNumber(UINT mNumber){

  return 0;
}


void CmTie::InitMessageStruct()
{
	CString tempS;

  	char szWork[256];

	strcpy( szWork, "Message was sent");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("MessageWasSent"), szWork, sizeof szWork);
	m_strMessageWasSent = szWork;

    m_ErrorMessageCount=7; 

	m_MSGStruct[0].LastTime=0;
   
	strcpy( szWork, "(1) Socket not created");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("SocketNotCreated"), szWork, sizeof szWork);
	// m_MSGStruct[0].Message="(1) Socket not created";
	m_MSGStruct[0].Message=szWork;
	m_MSGStruct[0].Status=1;

	strcpy( szWork, "(2) Socket client not created for");
//    e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("SocketClientNotCreated"), szWork, sizeof szWork);
	// tempS="(2) Not created client for ";
	tempS = szWork;
	tempS=tempS+KnotName;
	m_MSGStruct[1].LastTime=0;
  m_MSGStruct[1].Message=tempS;
	m_MSGStruct[1].Status=1;

	strcpy( szWork, "(3) Cannot connect to");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("CannotConnect"), szWork, sizeof szWork);
//	tempS="(3) Cannot connect to ";
	tempS = szWork;
	tempS=tempS+"$ ";
//	tempS=tempS+"$ from knot "+KnotName;
	m_MSGStruct[2].LastTime=0;
  m_MSGStruct[2].Message=tempS;
	m_MSGStruct[2].Status=1;

	m_MSGStruct[3].LastTime=0;

	strcpy( szWork, "(4) Invalid knot name");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("InvalidKnotName"), szWork, sizeof szWork);
//	m_MSGStruct[3].Message="(4) Invalid knot name ";
	tempS = szWork;
	m_MSGStruct[3].Status=1;

	  strcpy( szWork, "(5) Invalid IP address");
//    e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("InvalidIPAddress"), szWork, sizeof szWork);
//    tempS="(5) Invalid IP address "; 
	tempS = szWork;
	m_MSGStruct[4].LastTime=0;
    m_MSGStruct[4].Message=tempS;
	m_MSGStruct[4].Status=1;


	strcpy( szWork, "(6) Socket server not created for");
//    e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("SocketServerNotCreated"), szWork, sizeof szWork);
//	tempS="(6) Not created server for ";
	tempS = szWork;
	tempS=tempS+KnotName;
//	tempS=tempS+CString("\nCheck channel and try again");
	m_MSGStruct[5].LastTime=0;
  m_MSGStruct[5].Message=tempS;
	m_MSGStruct[5].Status=1;


	strcpy( szWork, "(7) Invalid communication properties\nof the $");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("InvalidCommunProperties"), szWork, sizeof szWork);
//	tempS="(7) Invalid communication properties \nof the $ ";
	tempS = szWork;
	m_MSGStruct[6].LastTime=0;
  m_MSGStruct[6].Message=tempS;
	m_MSGStruct[6].Status=1;

	
	m_MSGStruct[7].LastTime=0;
	strcpy( szWork, "(8) Read socket error");
//	e_pINIFileService->GetLangString((TCHAR * )cszSocketSection, _T("ReadSocketError"), szWork, sizeof szWork);
//    m_MSGStruct[7].Message="(8) Read socket error ";
	tempS = szWork;
	m_MSGStruct[7].Status=1;
}



void CmTie::ReStartAllSenders(){

 // CString tempIP;

	char								mSection[1024];
	char								*temp;
	CString							tempmName;
	CString							tempPref;	
	char								mSendName[50];
	struct CheckList		tempCheck;


//	KillTimer(55);
	GetPrivateProfileSectionNames(mSection,1023,m_iniFilePath);
  temp=mSection;
  while(temp[0]!='\0'){
    tempmName=temp;
		if(tempmName.GetLength()>4){	
			tempPref=tempmName.Mid(0,4);
			if(tempPref=="COMM"){
				tempmName=tempmName.Mid(4);
				strcpy(mSendName,(LPSTR)(LPCTSTR)tempmName);
				::SendMessage(m_SendHWND,WM_SENDTOCONNECT,0L,(LPARAM)mSendName);
			}
			temp=temp+strlen(temp)+1;
		}			
	}
	//SetTimer(55,300,NULL);
}


void CmTie::RemoveHistory(){
  m_seqSendMSGNumber=0;
	m_SendQueue.RemoveAll();
}



void CmTie::OnTimer(UINT nIDEvent)
{		

	static BOOL bIsActive = FALSE;
	
	if(m_SendQueue.GetCount()>0 && MaySend && bIsActive == FALSE )
	{
        bIsActive = TRUE;       
        BOOL bIsSendOK =  SendMsgFromQueue();
		if( bIsSendOK ==TRUE || ImManager==TRUE) 
		{
			if( !m_SendQueue.IsEmpty())      // 4.9.7.9.6
			      m_SendQueue.RemoveHead();   
		}
			
         if( bIsSendOK == TRUE && cuiCurrentInterval != cuiNormalInterval ) // 4.9.7.9.6
		 {  
			 cuiCurrentInterval = cuiNormalInterval;
             SetTimer( cuiTimerID, cuiCurrentInterval, NULL ); 
		 }// end of if( bIsSendOK == TRUE && cuiCurrentInterval )
		 else if( bIsSendOK == FALSE )
		 {
			  cuiCurrentInterval = cuiNoConnectInterval;
			  SetTimer( cuiTimerID, cuiCurrentInterval, NULL ); 
		 }
	}// end of if(m_SendQueue.GetCount()>0 && MaySend)
    bIsActive = FALSE;    
	CWnd::OnTimer(nIDEvent);
}// end of void CmTie::OnTimer(UINT nIDEvent)


BOOL CmTie::SendMsgDirect(LPSTR Receivername, void* strText,
													 WORD  mSize,
													 WORD  MesID)
{  
	CString             ToIp;
	UINT                mPort;   
	CTCPIPData					tempT;


	CurrentReceive=CString(Receivername);
	CurrentSenderID=GetIdFromName(Receivername);


	if(IsInList(Receivername,ToIp,mPort)==TRUE){ //MMR 17/08/2000
	}
	else{		
		ToIp=GetToIp(Receivername);    	 
		mPort=GetToPort(Receivername);
		//MMR 17/08/2000
		tempT.mPort=mPort;
		tempT.ToIp=ToIp;
		tempT.TargetName=Receivername;
		
		m_TCPIPData.AddTail(tempT);
		
	}

	//CurrentReceive=CString(Receivername);
	//ToIp=GetToIp(Receivername);    
	//mPort=GetToPort(Receivername);
	//CurrentSenderID=GetIdFromName(Receivername);

	return SendMsgDirect(mPort, ToIp, (void*)strText, mSize);  
}



BOOL CmTie::SendMsgDirect(UINT mPort, CString& ToIp, 
										void* mDataToPass,WORD mSize,
										int mType){

  
	BOOL					tempStatus=false;
 	CmServer			*tempserver;
	char					tempS[90];	


	CSendQueue tempQueue;

	m_seqSendMSGNumber++;



	memcpy(tempQueue.mDataToPass,mDataToPass,mSize);
	tempQueue.mNumber=m_seqSendMSGNumber;
	tempQueue.mPort=mPort;
	tempQueue.mSize=mSize;
	tempQueue.mType=mType;
	tempQueue.ToIp=ToIp;
	tempQueue.mName=CurrentReceive;

  
	tempserver=new CmServer(this);


	strcpy(tempS,"From Manager");	
	::SendMessage(m_SendHWND,WM_WRITEMESSAGE,(long)(LPSTR)(LPCTSTR)CurrentReceive,(long)&tempS);
		

	sprintf(tempS,"Preparation send to:%s %d",ToIp,mPort);
	SendErrorMessage(tempS,1);	

  
	if(tempserver->ConnectSocket(mPort,(LPSTR)(LPCTSTR)ToIp)){				
		if(mType==2){
			tempStatus=VBSendMsg(tempQueue,tempserver);
		}
		else{
			tempStatus=VCSendMsg(tempQueue,tempserver);
		}
	}
  

	delete tempserver;
	tempserver=NULL;
  

	return tempStatus;
}



CString CmTie::GetSubString(CString sourceStr, CString Separator, int mPlace){

  int				SepPlace;
	CString		ReturnStr;
	int				step;
	int				start;

	SepPlace=sourceStr.Find(Separator);

	step=1;
	start=0;
	ReturnStr="";

	while(SepPlace>-1){
    if(step==mPlace){
			ReturnStr=sourceStr.Mid(start,SepPlace-start);
			return ReturnStr;
		}
		start=SepPlace+1;
		SepPlace=sourceStr.Find(Separator,start);
		step++;
	}

  if(step==mPlace){
		SepPlace=sourceStr.GetLength();
		ReturnStr=sourceStr.Mid(start,SepPlace-start);
		return ReturnStr;
	}
	return ReturnStr;
}
