// File: mTie.h                 Date: 23-FEB-2003
//


#if !defined(AFX_MTIE_H__22F1A693_BC3F_11D3_A88A_00104B6ECFED__INCLUDED_)
#define AFX_MTIE_H__22F1A693_BC3F_11D3_A88A_00104B6ECFED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef MTIE_H
#define MTIE_H


#include "mserver.h"

const TCHAR cszSocketSection[] = "Socket";

#define MSGERROR        0
#define MSGALLRIGHT     1
#define MSGFAILED       2
#define MSGINPROGRESS   3
#define SUCCESSMESSAGE  "Message was Sent" 
#define COMMEXTENSION   "COMM"
//#define SEPARATOR       ':' 

/////////////////////////////////////////////////////////////////////////////
// CmTie window

struct CheckList{
  CString mName;
	CTime   mTime;
};


struct ShowMessage{  
	CString Message;
	int     Status; 
	CTime   LastTime;
};



typedef struct mPointMess{
  UINT mInput;
	UINT mOutput;
} CPointMess;


typedef struct mSendQueue{
  UINT				mPort;
	CString			ToIp;
	BYTE				mDataToPass[1024];
	WORD				mSize;
	int					mType;				//VB or VC
	int					mNumber;			//nuber of the message
	CString			mName;
}CSendQueue;

typedef struct TCPIPData{
	UINT			mPort;
	CString		ToIp;
	CString		TargetName;
}CTCPIPData;


class CmTie : public CWnd{	
public:
	CmTie();

	// Attributes
public:
	CString									CurrentReceive;	
	CString m_strMessageWasSent;

protected:
  CList<long,long&>       ServerList;
	BOOL										MaySend;

	// Operations
public:
	//BOOL				CreateAdditionalServer(UINT channel);
	BOOL				&SendStatus(){return MaySend;}
	BOOL				CreateMainServer(UINT channel, BOOL HowIAm);
	void				ProcessPendingRead(	CmServer* pSocket,
																CSendStructure& temps,
																NDDEDataToBePassed* mData,
																int mType);
	bool				ReadMsg(CmServer* pSocket,
                    CSendStructure& temps,
										NDDEDataToBePassed *mData,
										int mType); 
	void				CloseSocket(CmServer* pSocket);
	void				SetPauseStatus(BOOL mstatus);
	void				SendErrorMessage(CString str,long AddParam);
	//void				Message(LPCTSTR lpszMessage,
	//										LPCTSTR lpszMessage1);
	//void				SetListBox(	CListBox* templist,
	//												CListBox* tempsend);
	void				FillDBInfo();
	BOOL				SendMsg(UINT mPort, CString& ToIp, 
											void* mDataToPass,WORD mSize, int mType=0);
	BOOL				SendMsg(LPSTR Receivername, 
											void* strText,
											WORD  mSize,
											WORD  MesID=0);
	BOOL				SendMsgDirect(UINT mPort, CString& ToIp, 
											void* mDataToPass,WORD mSize, int mType=0);
	BOOL				SendMsgDirect(LPSTR Receivername, 
											void* strText,
											WORD  mSize,
											WORD  MesID=0);

	LPCTSTR			GetLocalIPAddress(LPSTR mIPAddress,
																LPSTR HostName);
	//float&			CheckInterval();
	CString&		IniFilePath();
	void				FillIniFile(CSendStructure* str, int mType=0);
	int					IsInINIFile(CSendStructure* tempSS);	
	//void				UpdateCheckList(CSendStructure* str);
	long				GetToPort(LPSTR tempS);
	CString			GetToIp(LPSTR tempS);
	CString			GetPath(CString str);
	CString			GetErrorMessage(int index);
	CString			GetErrorMessage(int index, CString text);
	long        GetIdFromName(LPSTR mName);
	int					GetOrderNumber(UINT mNumber);
	BOOL        Create(	CWnd* mParent,
											LPSTR mName, int mIndex,
											HWND mHW);
	bool				InitializeKnot(	CString mIP, 
															CString name,
															int mIndex);
	void				InitMessageStruct();
	void        ReStartAllSenders();
	void        RemoveHistory();
	void        CreateAlias(UINT channel,LPSTR mAlias);
	BOOL				VBSendMsg(CSendQueue&, CmServer* tempserver);
	BOOL				VCSendMsg(CSendQueue&, CmServer* tempserver);
	BOOL				SendMsgFromQueue();
	CString			GetSubString(CString sourceStr, CString Separator, int mPlace);
	
	BOOL				IsInList(LPSTR Receivername, CString &, UINT &);


	//LRESULT     SendToConnect( WPARAM wp, LPARAM lp );


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CmTie)
	//}}AFX_VIRTUAL


// Implementation
public:
	virtual ~CmTie();
  HWND                          m_SendHWND;
	long													CurrentSenderID;
	CString												GetIniFilePath(){return m_iniFilePath;};	
	void													toDebugFile(LPSTR str,LPSTR mName,WORD mID, int mNumber);
	void													ClearDebugFile();
	

	// Generated message map functions
protected:
	//{{AFX_MSG(CmTie)
		// NOTE - the ClassWizard will add and remove member functions here.
	  afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

public:
	CString												KnotIp;
	CString												KnotName;
	CString												KnotCode;
	int														KnotIndex;

protected:	
	
	long                          KnotMainChannel;
//  CListBox*                     m_listmessage; 
//  CListBox*                     m_sendmessage; 
//  float                         m_checkInterval;
	CString                       m_iniFilePath;
  CStringList                   m_ErrorMSGList;
	//m_checkList - names of all senders and connection last
	//time
	//CList<CheckList,CheckList&>    m_checkList;
	//m_MessPoints - pair of Message numbers input - output
	//corresponding to Vc2_wm.dbf
  CList<CPointMess,CPointMess&>		m_MessPoints;
	struct ShowMessage							m_MSGStruct[10];  
  int															m_ErrorMessageCount;
  int															m_seqSendMSGNumber;
  BOOL														PauseStatus;
  CmServer												*tempserver0;  
	CList<CSendQueue,CSendQueue&>		m_SendQueue;
	CList<CTCPIPData,CTCPIPData&>		m_TCPIPData;
	
	BOOL ImManager;	
	UINT cuiCurrentInterval;
};

#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MTIE_H__22F1A693_BC3F_11D3_A88A_00104B6ECFED__INCLUDED_)
