// File: remote controlDlg.cpp                     Date: 01-DEC-2004
//

#include "stdafx.h"
#include "math.h"
#include "remote control.h"
#include "remote controlDlg.h"
#include "communication_defs.h"
#include "SetCommPortDlg.h"
#include "cim_dde.h"
#include "Tokenizer.h"
#include  <fstream>
#include  <string>
#include  <strstream>
#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/*
 *  ===========================================================================
 *		Defines
 *  ===========================================================================
 */

//Add this define if debug mode is required 
#define ENABLE_DBG_MODE

//used for bitmap manipulations
#define STOP_MOVEMENT_BITMAP                    0x00//robot should be stopped
#define RESEARCH_KIT_MANUAL_NAV_BITMAP          0x0f//indicates if user is manual navigating the robot
#define RESEARCH_KIT_AUTO_MOVEMENTS_BITMAP      0x00//indication for automatic movements


#define RESEARCH_KIT_LEFT_BITMAP              0x01//left button
#define RESEARCH_KIT_RIGHT_BITMAP             0x02//right button
#define RESEARCH_KIT_FORWARD_BITMAP           0x04//forward button
#define RESEARCH_KIT_BACKWARD_BITMAP          0x08//backward button

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemotecontrolDlg dialog

CRemotecontrolDlg::CRemotecontrolDlg(CWnd* pParent /*=NULL*/)

	: CDialog(CRemotecontrolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRemotecontrolDlg)
	m_strDistance = _T("");
	m_strTurnTo = _T("");
	m_strEditX = _T("");
	m_strEditY = _T("");
	m_strEditTheta = _T("");
	m_strTurn = _T("");
	m_strUltraSoundThreshold = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


	m_p_com_thread = new CComThread;
	Init_com_port();
	m_remote_keys_bitmap = 0;
	m_send_packet_id = 0;
	m_last_comm_count = 0;

	m_keyboard_nav_cntrl = TRUE;
	m_halt_communication_count = 0;
	m_packet_editor_dlg_param1 = 0;
	m_packet_editor_dlg_param2 = 0;
	m_packet_editor_dlg_param3 = 0;
	m_packet_editor_dlg_param4 = 0;
	m_packet_editor_dlg_param5 = 0;
	m_packet_editor_dlg_param6 = 0;
	m_packet_editor_dlg_param7 = 0;
	m_disp_wnd_dlg = NULL;
	m_packet_editor_dlg = NULL;
	
	m_drive_motor_cmnd_end_reason = RESEARCH_KIT_DRIVE_MOV_DIST;
	m_ack_type = 2;

#ifdef DEMO_MODE
	m_demo_mode_state=0;
#endif DEMO_MODE

    m_bIsRobotRespond = FALSE;

	m_dwLastReceivedDataTick = 0;
	m_iCloseCounter = 0;
	m_bIsPathChanged = FALSE;
	m_bEndProgramMode = FALSE;
	m_bIsPause = FALSE;

    m_lDistance = m_lFirstDistanceCount = 1;
	m_sFirstHeading = 1;

	m_lPrevDistance = LONG_MAX;
	m_sPrevHeading = UCHAR_MAX;
	pKnot = NULL; 

	LastReceivedString.lCommandFromDevID = 0;
	m_bWasFalseBumperEvent = FALSE;

	m_lCurrentX = m_lX_PositError = 0;
	m_lCurrentY = m_lY_PositError = 0;
	m_sCurrentTheta = m_sTheta_PositError = 0;
	m_sHeadingCorrection = 0;

}// end of CRemotecontrolDlg::CRemotecontrolDlg(CWnd* pParent /*=NULL*/)

void CRemotecontrolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemotecontrolDlg)
	DDX_Control(pDX, IDC_RADIO_BY_USER, m_ByUser );
	DDX_Control(pDX, IDC_RADIO_ANY, m_Any);
	DDX_Control(pDX, IDC_RADIO_AUTO, m_Automatic);
	DDX_Control(pDX, IDC_RADIO_MANUAL, m_Manual);
	DDX_Control(pDX, IDC_LISTBOX_MESSAGES, m_CIM_Messages_List);
	DDX_Control(pDX, IDC_COMBO_CIM_MODES, m_CIM_Modes);
	DDX_Control(pDX, IDC_STATIC_STATUS, m_StaticStatus);
	DDX_Control(pDX, IDC_COMBO_PATH_NAME, m_ComboPathName);
	DDX_Control(pDX, IDC_COMBO_POSIT_NUMBER, m_ComboPositNumber);
	DDX_Control(pDX, IDC_COMBO_SPEED, m_ComboSpeed);
	DDX_Control(pDX, IDC_BUTTON_RIGHT, m_right_button);
	DDX_Control(pDX, IDC_BUTTON_LEFT, m_left_button);
	DDX_Control(pDX, IDC_BUTTON_DOWN, m_backward_button);
	DDX_Control(pDX, IDC_BUTTON_UP, m_forward_button);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_stop_button);
	DDX_Text(pDX, IDC_EDIT_DISTANCE, m_strDistance);
	DDX_Text(pDX, IDC_EDIT_TURN_TO, m_strTurnTo);
	DDX_Text(pDX, IDC_EDIT_X, m_strEditX);
	DDX_Text(pDX, IDC_EDIT_Y, m_strEditY);
	DDX_Text(pDX, IDC_EDIT_THETA, m_strEditTheta);
	DDX_Text(pDX, IDC_EDIT_TURN, m_strTurn);
	DDX_Control(pDX, IDC_VSFLEXGRID1, m_ListPosit);
	DDX_Text(pDX, IDC_EDIT_ULTRASOUND_THRESHOLD, m_strUltraSoundThreshold);
	DDX_Control(pDX, IDC_VTEXT1, m_Speaker);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRemotecontrolDlg, CDialog)
	//{{AFX_MSG_MAP(CRemotecontrolDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_UP, On_button_forward)
	ON_BN_CLICKED(IDC_BUTTON_LEFT, On_button_left)
	ON_BN_CLICKED(IDC_BUTTON_STOP, On_button_stop)
	ON_BN_CLICKED(IDC_BUTTON_RIGHT, On_button_right)
	ON_BN_CLICKED(IDC_BUTTON_DOWN, On_button_backward)
	ON_COMMAND(ID_SETTINGS_COMMUNICATION_PORT, On_set_communication_port)
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_COMMAND(ID_SETTINGS_PACKETEDITOR, OnSettingsPacketeditor)
	ON_COMMAND(ID_TOOLS_DISPLAY_WINDOW, OnToolsDisplayWindow)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_BN_CLICKED(IDC_BUTTON_GO, OnButtonGo)
	ON_BN_CLICKED(IDC_BUTTON_SET_HOME, OnButtonSetHome)
	ON_BN_CLICKED(IDC_BUTTON_TURN_TO, OnButtonTurnTo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_TEACH, OnButtonTeach)
	ON_BN_CLICKED(IDC_BUTTON_GO2, OnButtonGoCartes)
	ON_BN_CLICKED(IDC_BUTTON_TURN, OnButtonTurn)
	ON_BN_CLICKED(IDC_BUTTON_LOCALIZE, OnButtonLocalize)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_POSIT, OnButtonDeletePosit)
	ON_COMMAND(IDC_OPEN_FILE, OnOpenFile)
	ON_COMMAND(IDC_SAVE_FILE, OnSaveFile)
	ON_COMMAND(IDC_SAVE_AS_FILE, OnSaveAsFile)
	ON_COMMAND(IDC_EXIT, OnExit)
	ON_COMMAND(IDCANCEL, OnCancel)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_ADD_PATH, OnButtonAddPath)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_PATH, OnButtonDeletePath)
	ON_BN_CLICKED(IDC_BUTTON_GO_ALONG, OnButtonGoAlong)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_LIST_POSIT, OnButtonClearListPosit)
	ON_CBN_SELCHANGE(IDC_COMBO_POSIT_NUMBER, OnSelchangeComboPositNumber)
	ON_CBN_SELCHANGE(IDC_COMBO_PATH_NAME, OnSelchangeComboPathName)
	ON_BN_CLICKED(IDC_BUTTON_HOMING, OnButtonHoming)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, OnButtonPause)
	ON_BN_CLICKED(IDC_BUTTON_CONTINUE, OnButtonContinue)
	ON_CBN_SELCHANGE(IDC_COMBO_CIM_MODES, OnSelchangeComboCimModes)
	ON_BN_CLICKED(IDC_RADIO_AUTO, OnRadioAuto)
	ON_BN_CLICKED(IDC_RADIO_MANUAL, OnRadioManual)
	ON_BN_CLICKED(IDC_RADIO_BY_USER, OnRadioByUser)
	ON_WM_CHAR()
	ON_MESSAGE(WM_USER_RCV_PACKET,On_receive_packet)
	ON_BN_CLICKED(IDC_RADIO_ANY, OnRadioAny)
	//}}AFX_MSG_MAP

	ON_MESSAGE( WM_CIMDDE_SENDSTRING, AGVDriver_ReceivedString )
	ON_MESSAGE( WM_CIM_DRAWLINE,	AGVDriver_DrawLine )

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemotecontrolDlg message handlers

BOOL CRemotecontrolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    TCHAR szWork[256];
	if( Daddy -> m_iIdOfDevice[0] == LOGICAL_NO_ID )
         SetWindowText( cszApplName );
	else
	{
        _stprintf( szWork, "%s. Device ID: %d", cszApplName, Daddy -> m_iIdOfDevice[0] );
		SetWindowText( szWork );
	}
	

	//load icons on the dialog buttons
	m_forward_button.SetIcon(AfxGetApp()->LoadIcon(IDI_FORWARD));
	m_backward_button.SetIcon(AfxGetApp()->LoadIcon(IDI_BACKWARD));
	m_right_button.SetIcon(AfxGetApp()->LoadIcon(IDI_RIGHT));
	m_left_button.SetIcon(AfxGetApp()->LoadIcon(IDI_LEFT));
	m_stop_button.SetIcon(AfxGetApp()->LoadIcon(IDI_STOP));

    m_bIsGo = m_bIsTurnTo = m_bIsTurn = m_bIsGoCartes = m_bIsGoPath = m_bIsHoming = FALSE;
	m_bIsCommandFinished = TRUE;
	m_bIsCommandReceived = FALSE;
	m_bWasRepeatMoveRobot = FALSE;

	m_strDistance = "100";
	m_strTurnTo = m_strTurn = "90";

	m_strEditX = "0";
	m_strEditY = "0";
	m_strEditTheta = "0";

	for( int i = 1; i < 20; i++)
         m_ComboSpeed.AddString( itoa( i, szWork, 10 ));

    int iIndex;
	m_ComboSpeed.SetCurSel((iIndex = m_ComboSpeed.FindStringExact(-1, "19")) == CB_ERR ? 0 : iIndex);
	

	m_ByUser.SetCheck( BST_CHECKED );
	m_Any.SetCheck( BST_UNCHECKED );
	OnRadioByUser();

	const char szZero[] = "0";
    SetDlgItemText(IDC_STATIC_X, szZero );
	SetDlgItemText(IDC_STATIC_Y, szZero );
	SetDlgItemText(IDC_STATIC_THETA, szZero );

	m_ListPosit.SetEditable(TRUE);
	m_ListPosit.SetExtendLastCol(TRUE);
       
	m_ListPosit.SetRows(ciMaxRows);
	m_ListPosit.SetCols(3);
	m_ListPosit.SetFixedRows(1);
	m_ListPosit.SetFixedCols(1);			
	m_ListPosit.SetTextMatrix(0, 0, "No");
	m_ListPosit.SetTextMatrix(0, 1, "Number");
	m_ListPosit.SetTextMatrix(0, 2, "Speed");
	m_ListPosit.SetColComboList(1, " ");
	m_ListPosit.SetColComboList(2, "1|2|3|4|5|6|7|8|9|10");
	

	for( i = 1; i < ciMaxRows; i++ )
	{
       m_ListPosit.SetTextMatrix(i, 0, itoa(i, szWork, 10));
	   m_ListPosit.SetTextMatrix(i, 2, "10");
	}// end of for( i = 1; i < ciMaxRows; i++ )

	for(i=0;i<3;i++)
		m_ListPosit.SetColAlignment(i,4);   // 4 - flexAlignCenterCenter

	m_ListPosit.SetAllowUserResizing(1);   // The user may resize column widths.
	m_ListPosit.SetAllowSelection(FALSE);

	COleVariant varCols((long)(m_ListPosit.GetCols() - 1));
	COleVariant varEqual((long)0);
	COleVariant varExtraSpace((long)0);
	m_ListPosit.AutoSize( 0, varCols, varEqual, varExtraSpace );

	m_CIM_Modes.AddString(cszOnline);
	m_CIM_Modes.AddString(cszSimulation);
	m_CIM_Modes.AddString(cszStandalone);

	m_CIM_Modes.SetCurSel( GetComboIndexOfDDModes( Daddy->cmMode ));

	OnSelchangeComboCimModes();

	SetDlgItemText(IDC_STATIC_CIM_PATH_TEXT, Daddy->m_szHomeDir );

//#if 0
	char	szBuf[256];
	int		index;
	int		index1;

	strcpy( szBuf, "ACL");
	if(  pKnot == NULL && Daddy->m_iIdOfDevice[0] != LOGICAL_NO_ID )
	{
		SetCurrentDirectory( Daddy->m_szHomeDir );
		pKnot=new CmTie();
		pKnot->Create(this,szBuf,Daddy->m_iIdOfDevice[0],m_hWnd);	
		pKnot->IniFilePath()=Daddy->m_szMapINI;  
		//pKnot->CheckInterval()=120;	
		pKnot->CreateMainServer(700+Daddy->m_iIdOfDevice[0],FALSE);
		pKnot->SetPauseStatus(TRUE);
		pKnot->SendStatus()=TRUE;


		SetDlgItemText(IDC_STATIC_IP_ADDRESS_TEXT, pKnot->KnotIp );

		  for(index=1;index<MAX_LOGICALIDOFDEVICE ;index++)
		  {
				if(Daddy->m_iIdOfDevice[index]>0)
				{
				   sprintf( szBuf, "ACL%d", Daddy->m_iIdOfDevice[index] );
				   pKnot->CreateAlias(700+Daddy->m_iIdOfDevice[index], szBuf);
				}
		  }// end of for(index=1;index<MAX_LOGICALIDOFDEVICE ;index++)

	  //find redirection in the map.ini
		char			temp[1024];
	  long			addChannel;
		char			tempS[30];
		CString		tempStr;
		char			tempId[10];
		int       mOffSet;

		itoa(Daddy->m_iIdOfDevice[0],tempId,10);

		GetPrivateProfileSection("REDIRECT",
								  temp,1023, 
										Daddy->m_szMapINI);
		strncpy(tempS,temp,29);
		mOffSet=strlen(tempS);
		tempS[mOffSet+1]='\0';
		while(tempS[0]!='\0'){
		tempStr=tempS;
			index=tempStr.Find(tempId);
			index1=tempStr.Find("=");
			if(index==index1+1){
				tempStr=tempStr.Mid(0,index1);
			  addChannel=atol(tempStr);
				if(addChannel!=0L){ 
					sprintf( szBuf, "ACL%d", addChannel );
					pKnot->CreateAlias(700+addChannel, szBuf);	 
				}
			}
			strcpy(tempS,temp+mOffSet+1);
			mOffSet=mOffSet+strlen(tempS)+1;
		} 

		//end redirection

//		bCommDisabled = FALSE;

		if( !SetTimer( TIMER_ID_CIM, TIMER_INTERVAL_CIM ,NULL))
		{
			MessageBox(_T("SetTimer() function failure"),_T("ERROR"),MB_ICONSTOP|MB_OK);
			::ExitProcess(1);
			return(-1);
		}

//        SendMessage( WM_CIMDDE_INIT, 0xDDDD, 0L );
	}// end of if(  pKnot == NULL && Daddy->m_iIdOfDevice[0] != LOGICAL_NO_ID )
//#endif


	TCHAR szSection[41] = "General";

	m_strINIfilePath.Format("%s%s", Daddy->m_szHomeDir, Daddy->m_strDD_INIFileName );
		
	GetPrivateProfileString(szSection, "DelayAfterObstacle_sec", "10", szWork, sizeof(szWork), m_strINIfilePath);
	m_iDelayAfterObstacle_ms = atoi(szWork) * 1000;

	if ( GetExecDir( m_szExecDir ) == FALSE )
	{
			MessageBox(_T("Cannot get the executable path"),_T("ERROR"),MB_ICONSTOP|MB_OK);
			::ExitProcess(1);
			return(-1);
	}

	
	GetPrivateProfileString(szSection, "ApplicationLanguage", "eng", szWork, sizeof(szWork), m_strINIfilePath);
	m_strAppLanguageFilePath.Format("%sAGVDD.%s", m_szExecDir, szWork);

	GetPrivateProfileString(szSection, "UltraSoundThreshold", "350", szWork, sizeof(szWork), m_strINIfilePath);
 
	m_strUltraSoundThreshold = szWork;
	m_sUltraSoundThreshold = (short)atol( szWork );

	UpdateData(FALSE);

    if( Daddy->m_strLoadPathsFileName.IsEmpty() == 0 )
	{
		m_strPathFillFullName = m_szExecDir + Daddy->m_strLoadPathsFileName;
		OpenPathsFile( m_strPathFillFullName );
	}
      

	//adding a timer
	if(!SetTimer(ID_TIMER,TIMER_PERIOD,NULL))
	{
		MessageBox(_T("SetTimer() function failure"),_T("ERROR"),MB_ICONSTOP|MB_OK);
		::ExitProcess(1);
		return(-1);
	}

	RequestForMotionInfo();

	return TRUE;  // return TRUE  unless you set the focus to a control
}// end of BOOL CRemotecontrolDlg::OnInitDialog()

void CRemotecontrolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRemotecontrolDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRemotecontrolDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//initialize communication ports
void CRemotecontrolDlg::Init_com_port(void)
{

	BOOL status = TRUE;
	DCB Dcb_com;
	COMMTIMEOUTS Cto_com;
	CString serial_port_str = _T("");

	CString strWork;

	switch(((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id)
	{
		case COM1_PORT:
		default:
			serial_port_str = _T("COM1");
			break;

		case COM2_PORT:
			serial_port_str = _T("COM2");
			break;

		case COM3_PORT:
			serial_port_str = _T("COM3");
			break;

		case COM4_PORT:
			serial_port_str = _T("COM4");
			break;

		case COM5_PORT:
			serial_port_str = _T("COM5");
			break;

		case COM6_PORT:
			serial_port_str = _T("COM6");
			break;

	}// end of switch(((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id)

	//set com port
	m_h_com = CreateFile(serial_port_str,(GENERIC_READ | GENERIC_WRITE),0,NULL,OPEN_EXISTING,
					  FILE_FLAG_OVERLAPPED,NULL);
	status = GetCommState(m_h_com,&Dcb_com);
	if(!status)
	{
		strWork.Format("Cannot open %s. Check if it's already opened.", serial_port_str);
        ::MessageBox(this->m_hWnd, strWork,"Error",MB_OK | MB_SETFOREGROUND | MB_ICONERROR); 
	}
		

	Dcb_com.BaudRate = ((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate;
	Dcb_com.ByteSize = 8;
	Dcb_com.Parity = NOPARITY;
	Dcb_com.StopBits = ONESTOPBIT;
	Dcb_com.fAbortOnError  = FALSE;
	if(status)
	{
		status = SetCommState(m_h_com,&Dcb_com);
		if(!status)
			::MessageBox(this->m_hWnd,"COM1 failed. check if it's already opened","Error",MB_OK | MB_SETFOREGROUND | MB_ICONERROR);

		// Set time outs to zero - read/write operations will return only 
		// upon reading/writing the requested number of bytes.
		GetCommTimeouts(m_h_com,&Cto_com);
		Cto_com.ReadIntervalTimeout = 0;
		Cto_com.ReadTotalTimeoutMultiplier = 0;
		Cto_com.ReadTotalTimeoutConstant = 0;
		Cto_com.WriteTotalTimeoutMultiplier = 0;
		Cto_com.WriteTotalTimeoutConstant = 0;
		SetCommTimeouts(m_h_com,&Cto_com);
		m_p_com_thread->Set_com_handle(m_h_com);
	}
}

int CRemotecontrolDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	

	//send the CComThread class a handle to CMainFrame window
	m_p_com_thread->m_com_flags.m_h_rcv_wnd = m_hWnd;
	
	return 0;
}

void CRemotecontrolDlg::OnDestroy() 
{
	KillTimer(ID_TIMER);

	if(pKnot)
	{
		delete pKnot;
		pKnot=NULL;		
	}

	if(m_p_com_thread)
	{
        delete m_p_com_thread; 
        m_p_com_thread = NULL; 
	}
		
	if(m_disp_wnd_dlg)
		delete m_disp_wnd_dlg;

	if(m_packet_editor_dlg)
		delete m_packet_editor_dlg;

	//Writing last used settings to the registry
	((CRemotecontrolApp*)AfxGetApp())->WriteProfileInt(HARDWARE_SECTION,SERIAL_PORT_ENTRY,((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id);
	((CRemotecontrolApp*)AfxGetApp())->WriteProfileInt(HARDWARE_SECTION,BAUD_RATE_ENTRY,((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate);

	CDialog::OnDestroy();
}// end of void CRemotecontrolDlg::OnDestroy()


//////////////////////////////////////////////////////
//called when one of the navigaton buttons is pressed
void CRemotecontrolDlg::On_button_forward() 
{
	m_halt_communication_count = -1;
	m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
	m_remote_keys_bitmap |= RESEARCH_KIT_FORWARD_BITMAP;
	m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
	m_keyboard_nav_cntrl = FALSE;
	Transmit_packet(FALSE,RESEARCH_KIT_NAVIGATION_ID);  // Shimon
#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
}

void CRemotecontrolDlg::On_button_left() 
{
	m_halt_communication_count = -1;
	m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
	m_remote_keys_bitmap |= RESEARCH_KIT_LEFT_BITMAP;
	m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
	m_keyboard_nav_cntrl = FALSE;
	Transmit_packet(FALSE,RESEARCH_KIT_NAVIGATION_ID);  // Shimon
#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
}

void CRemotecontrolDlg::On_button_stop() 
{
    m_bIsCommandFinished = TRUE;
	m_bIsCommandReceived = FALSE;
	if ( m_bIsGo == TRUE )
	{
		m_bIsGo = FALSE;
		m_sFirstHeading = m_sHeading;
		m_lFirstDistanceCount = m_lDistance;
		MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 );
	}// end of else .if ( m_bIsGo == TRUE )
	else if ( m_bIsTurnTo == TRUE )
	{
		m_bIsTurnTo = FALSE;
		m_sFirstHeading = m_sHeading;
		m_lFirstDistanceCount = m_lDistance;
		MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 );
	}
	else if ( m_bIsTurn == TRUE )
	{
		m_bIsTurn = FALSE;
		m_sFirstHeading = m_sHeading;
		m_lFirstDistanceCount = m_lDistance;
		MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 );
	}
	else if ( m_bIsGoCartes == TRUE )
	{
		m_bIsGoCartes = FALSE;
		m_sFirstHeading = m_sHeading;
		m_lFirstDistanceCount = m_lDistance;
		MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 );
	}
	else if ( m_bIsGoPath == TRUE )
	{
         m_bIsGoPath = m_bIsGoCartes = FALSE;
		 m_sFirstHeading = m_sHeading;
		 m_lFirstDistanceCount = m_lDistance;
		 MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 );
	}
	else if ( m_bIsHoming == TRUE )
	{  
		m_bIsHoming = FALSE;
		m_sFirstHeading = m_sHeading;
		m_lFirstDistanceCount = m_lDistance;
        MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 ); 
	}
	else
	{
		m_halt_communication_count = -1;
		m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
		m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
		m_keyboard_nav_cntrl = TRUE;
	}

	ClearMovementFlags();
	m_bEndProgramMode = TRUE;

#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG

}// end of void CRemotecontrolDlg::On_button_stop() 

void CRemotecontrolDlg::On_button_right() 
{
	m_halt_communication_count = -1;
	m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
	m_remote_keys_bitmap |= RESEARCH_KIT_RIGHT_BITMAP;
	m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
	m_keyboard_nav_cntrl = FALSE;
	Transmit_packet(FALSE,RESEARCH_KIT_NAVIGATION_ID);  // Shimon
#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
}

void CRemotecontrolDlg::On_button_backward() 
{
	m_halt_communication_count = -1;
	m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
	m_remote_keys_bitmap |= RESEARCH_KIT_BACKWARD_BITMAP;
	m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
	m_keyboard_nav_cntrl = FALSE;
	Transmit_packet(FALSE,RESEARCH_KIT_NAVIGATION_ID);  // Shimon
#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
}

/////////////////////////////////////////////////////////////

//calculate the check sum for a given packet
byte CRemotecontrolDlg::Check_sum(byte* packet,int length)
{
	long sum=0;

	for (int i=0;i<length;i++)
		sum += packet[i];
	return((byte)(~sum));
}

//called in order to display the communication setting dialog
void CRemotecontrolDlg::On_set_communication_port() 
{
	CString error_str = _T("");
	BOOL status = FALSE;
	DCB Dcb_com;
	COMMTIMEOUTS Cto_com;
	CSetCommPortDlg dlg(this);

	switch(((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id)
	{
		case COM1_PORT:
		default:
			dlg.m_port_name = _T("COM1");
			break;

		case COM2_PORT:
			dlg.m_port_name = _T("COM2");
			break;

		case COM3_PORT:
			dlg.m_port_name = _T("COM3");
			break;

		case COM4_PORT:
			dlg.m_port_name = _T("COM4");
			break;

		case COM5_PORT:
			dlg.m_port_name = _T("COM5");
			break;

		case COM6_PORT:
			dlg.m_port_name = _T("COM6");
			break;

	}// end of switch(((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id)
		
	switch(((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate)
	{
	case CBR_9600:
		dlg.m_port_baud_rate = _T("9600");
		break;

	case CBR_19200:
		dlg.m_port_baud_rate = _T("19200");
		break;

	case CBR_38400:
		dlg.m_port_baud_rate = _T("38400");
		break;
		
	default:
		dlg.m_port_baud_rate = _T("");
		break;
	}
	if(dlg.DoModal()==IDOK)
	{
		CString serial_port_str = _T("");

		if(dlg.m_port_name == _T("COM1"))
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM1_PORT;
			serial_port_str = _T("COM1");
		}
		else if(dlg.m_port_name == _T("COM2"))
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM2_PORT;
			serial_port_str = _T("COM2");
		}
		else if(dlg.m_port_name == _T("COM3"))
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM3_PORT;
			serial_port_str = _T("COM3");
		}
		else if(dlg.m_port_name == _T("COM4"))
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM4_PORT;
			serial_port_str = _T("COM4");
		}
		else if(dlg.m_port_name == _T("COM5"))
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM5_PORT;
			serial_port_str = _T("COM5");
		}
		else if(dlg.m_port_name == _T("COM6"))
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM6_PORT;
			serial_port_str = _T("COM6");
		}
		else
		{
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_id = COM1_PORT;
			serial_port_str = _T("COM1");
		}
		
		if(dlg.m_port_baud_rate == _T("9600"))
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate = CBR_9600;
		else if(dlg.m_port_baud_rate == _T("19200"))
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate = CBR_19200;
		else if(dlg.m_port_baud_rate == _T("38400"))
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate = CBR_38400;
		else
			((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate = CBR_38400;
		
		m_p_com_thread->Close_com_handle();

		// Configure default hardware configuration
		m_h_com = CreateFile((LPCTSTR)serial_port_str,(GENERIC_READ | GENERIC_WRITE),0,NULL,OPEN_EXISTING,
						  FILE_FLAG_OVERLAPPED,NULL);
		status = GetCommState (m_h_com,&Dcb_com);
		if(!status)
		{
			error_str = serial_port_str + " failed\ncheck if it's already opened";
			::MessageBox(this->m_hWnd,error_str,"Error",MB_OK | MB_SETFOREGROUND | MB_ICONERROR);
		}
		Dcb_com.BaudRate = ((CRemotecontrolApp*)AfxGetApp())->m_serial_port_baud_rate;
		Dcb_com.ByteSize = 8;
		Dcb_com.Parity = NOPARITY;
		Dcb_com.StopBits = ONESTOPBIT;
		if(status)
		{
			status = SetCommState (m_h_com,&Dcb_com);
			if(!status)
			{
				error_str = serial_port_str + " failed\ncheck if it's already opened";
				::MessageBox(this->m_hWnd,error_str,"Error",MB_OK | MB_SETFOREGROUND | MB_ICONERROR);
			}
		}
		// Set time outs to zero - read/write operations will return only 
		// upon reading/writing the requested number of bytes.
		GetCommTimeouts(m_h_com,&Cto_com);
		Cto_com.ReadIntervalTimeout = 0;
		Cto_com.ReadTotalTimeoutMultiplier = 0;
		Cto_com.ReadTotalTimeoutConstant = 0;
		Cto_com.WriteTotalTimeoutMultiplier = 0;
		Cto_com.WriteTotalTimeoutConstant = 0;
		SetCommTimeouts(m_h_com,&Cto_com);
		m_p_com_thread->Set_com_handle(m_h_com);
	}	
}

//this is the implementation for the ID_TIMER timer that was created.
//this function will be called periodically every TIMER_PERIOD ms
void CRemotecontrolDlg::OnTimer(UINT nIDEvent) 
{
	unsigned short remote_transmit_period = 0;

	static BOOL bIsMessageBox = FALSE;

	static int iInitCounter = 0;
	if(nIDEvent == ID_TIMER)
	{

		if( m_iCloseCounter > 0 )
		{
			m_iCloseCounter++;

			if( m_iCloseCounter == 5 )
				RequestForMotionInfo(FALSE);

			if( m_iCloseCounter == 10 )
			{
				CDialog::OnOK();
			}// end of if( m_iCloseCounter == 10 )
			return;
		}// end of if( m_iCloseCounter > 0 )
			
		//if case the remote control is disabled - enable it 
		{

//			CTime time = CTime::GetCurrentTime();
		   m_dwTimerTick = GetTickCount();
           if( m_dwTimerTick - m_dwLastReceivedDataTick > 250 && m_dwLastReceivedDataTick == 0 )    
                     RequestForMotionInfo();
		    	
           iInitCounter++;
		   if( m_dwTimerTick - m_dwLastReceivedDataTick > 900 && iInitCounter > 300  && bIsMessageBox == FALSE )    
			{
				bIsMessageBox = TRUE;
				m_bIsRobotRespond = FALSE; 

				Speaker( "ControllerNotRespond", "No connection with controller" );


#if 0
                if( AfxMessageBox( "Robot controller isn't responding!\n\nDo you want to close the application?",
					             MB_YESNO | MB_ICONERROR | MB_OK ) == IDYES )
				{
					SendMessage(WM_CLOSE);
					return;
				}

				else
				{
                    RequestForMotionInfo();
//					iInitCounter = 0;
				}

				bIsMessageBox = FALSE;
#endif
				return;
			}
		   else if ( m_dwTimerTick - m_dwLastReceivedDataTick < 900 )
			{
                  m_bIsRobotRespond = TRUE; 
				  if ( bIsMessageBox == TRUE )
				  {
	  				   bIsMessageBox = FALSE;
					   m_StaticStatus.SetWindowText("");
				  }
			 }
			 else
			 {

				 if( iInitCounter % 8 == 0 )
					 RequestForMotionInfo();
			 }
			   

			//check if we should enable/disable buttons/controls
			if(((m_remote_keys_bitmap & RESEARCH_KIT_MANUAL_NAV_BITMAP) && (m_keyboard_nav_cntrl)) ||
			   (m_remote_keys_bitmap & RESEARCH_KIT_AUTO_MOVEMENTS_BITMAP))
		
			{
				m_stop_button.SetFocus();

				if(::IsWindow(m_forward_button))
					m_forward_button.EnableWindow(FALSE);
				if(::IsWindow(m_backward_button))
					m_backward_button.EnableWindow(FALSE);
				if(::IsWindow(m_right_button))
					m_right_button.EnableWindow(FALSE);
				if(::IsWindow(m_left_button))
					m_left_button.EnableWindow(FALSE);
			}
			else
			{
				if(::IsWindow(m_forward_button))
					m_forward_button.EnableWindow(TRUE);
				if(::IsWindow(m_backward_button))
					m_backward_button.EnableWindow(TRUE);
				if(::IsWindow(m_right_button))
					m_right_button.EnableWindow(TRUE);
				if(::IsWindow(m_left_button))
					m_left_button.EnableWindow(TRUE);
			}

            BOOL bWasTransmit = Executer();
			if(m_remote_keys_bitmap & RESEARCH_KIT_AUTO_MOVEMENTS_BITMAP)
				remote_transmit_period = REMOTE_AUTO_MODE_TRANSMIT_PERIOD;
			else
				remote_transmit_period = REMOTE_MANUAL_MODE_TRANSMIT_PERIOD;
			
			//perform needed actions to make the manual navigation from the keyboard act just
			//like the real IR remote control
			{
				static byte prev_manual_nav_keys_bitmap=0;
				byte manual_nav_keys_bitmap=0;

				//if movement was forward and forward key was released wait a little before
				//stopping the robot to see if the user wants to perform curve movements
				manual_nav_keys_bitmap = (m_remote_keys_bitmap & RESEARCH_KIT_MANUAL_NAV_BITMAP);
				if(manual_nav_keys_bitmap != prev_manual_nav_keys_bitmap)
				{
					if((prev_manual_nav_keys_bitmap == RESEARCH_KIT_FORWARD_BITMAP) && (m_halt_communication_count != -1))
						m_halt_communication_count = REMOTE_POSTPONE_STOP_COMMAND_COUNT;
					prev_manual_nav_keys_bitmap = manual_nav_keys_bitmap;
				}
				if(m_halt_communication_count == -1)
					m_halt_communication_count = 0;
				else if(m_halt_communication_count)
					m_halt_communication_count--;
			}
			
		
#if 0			
			//transmit needed data to the robot 
			if(((count++ >= (remote_transmit_period/TIMER_PERIOD)) || (m_send_packet_now)) && (!m_halt_communication_count))
			{
				//send navigation command
				count = 0;
				
				if( bWasTransmit == FALSE )
				{
				  Transmit_packet(FALSE,RESEARCH_KIT_NAVIGATION_ID);   
//					Transmit_packet(FALSE,RESEARCH_KIT_DUMMY_ID);                  // Don't work
					m_send_packet_now = FALSE;
				}// end of if( bWasTransmit == FALSE )
			}
#endif 
			//
			//transmit required packets to the robot 
			//
			
			m_last_comm_count++;
			
			//transmit dummy packet if needed - to prevent robot from going to sleep
			{
				if(m_last_comm_count++ >= (REMOTE_TRANSMIT_PERIOD/TIMER_PERIOD))
				{
					m_send_packet_id = RESEARCH_KIT_DUMMY_ID;
					m_packet_editor_dlg_param1 = RESEARCH_KIT_DUMMY_ID;
				}
			}


			{
				static USHORT count=0;
				static last_remote_keys_bitmap=0;
				
				if(m_remote_keys_bitmap != last_remote_keys_bitmap)
					m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
				
				if( ((m_remote_keys_bitmap) && (count++ >= (remote_transmit_period/TIMER_PERIOD))) && 
					(!m_halt_communication_count) )
				{
					//send navigation command
					count = 0;
					m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
				}
			}

#ifdef DEMO_MODE
			{
				static short postpone = 50;
				
				if(postpone)
					postpone--;
				else
				{
					switch(m_demo_mode_state)
					{
					case 0://head
						m_send_packet_id = RESEARCH_KIT_ROBOT_MOTOR_ID;
						m_packet_editor_dlg_param1 = 4;
						m_packet_editor_dlg_param2 = 2;
						m_packet_editor_dlg_param3 = 2;
						m_packet_editor_dlg_param4 = 12;
						m_packet_editor_dlg_param5 = 360;
						m_packet_editor_dlg_param6 = 25;
						m_packet_editor_dlg_param7 = 0;
						m_demo_mode_state++;
						break;

					case 1:
						//wait for movement to end
						break;

					case 2://turn
						m_send_packet_id = RESEARCH_KIT_ROBOT_MOTOR_ID;
						m_packet_editor_dlg_param1 = 4;
						m_packet_editor_dlg_param2 = 2;
						m_packet_editor_dlg_param3 = 5;
						m_packet_editor_dlg_param4 = 60;
						m_packet_editor_dlg_param5 = 90;
						m_demo_mode_state++;
						break;
						
					case 3:
						//wait for movement to end
						break;

					default:
						m_demo_mode_state = 0;
						break;
					}
				}
			}
#endif DEMO_MODE

			if(m_send_packet_id)
			{
				Transmit_packet(FALSE,m_send_packet_id);
				m_send_packet_id = 0;
			}
		}
	}

	CDialog::OnTimer(nIDEvent);
}// end of void CRemotecontrolDlg::OnTimer(UINT nIDEvent) 

//called when a key in the keyboard is pressed
void CRemotecontrolDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    if( nChar == VK_F5)
	{
       On_button_stop();
	}


#if 0
	m_halt_communication_count = -1;
	switch(nChar)
	{
	case VK_LEFT:
	case VK_NUMPAD4:
		if(m_keyboard_nav_cntrl)
			m_remote_keys_bitmap |= RESEARCH_KIT_LEFT_BITMAP;
		else
		{
			m_keyboard_nav_cntrl = TRUE;
			m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
		}
		break;

	case VK_RIGHT:
	case VK_NUMPAD6:
		if(m_keyboard_nav_cntrl)
			m_remote_keys_bitmap |= RESEARCH_KIT_RIGHT_BITMAP;
		else
		{
			m_keyboard_nav_cntrl = TRUE;
			m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
		}
		break;

	case VK_UP:
	case VK_NUMPAD8:
		if(m_keyboard_nav_cntrl)
			m_remote_keys_bitmap |= RESEARCH_KIT_FORWARD_BITMAP;
		else
		{
			m_keyboard_nav_cntrl = TRUE;
			m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
		}
		break;

	case VK_DOWN:
	case VK_NUMPAD2:
		if(m_keyboard_nav_cntrl)
			m_remote_keys_bitmap |= RESEARCH_KIT_BACKWARD_BITMAP;
		else
		{
			m_keyboard_nav_cntrl = TRUE;
			m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
		}
		break;

	default:
		m_keyboard_nav_cntrl = TRUE;
		m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
		break;
	}

	//check if the key was already pressed 
	if(!(nFlags&0x4000))
				m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;

#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
#endif

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}// end of void CRemotecontrolDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 

//called when a key in the keyboard is released
void CRemotecontrolDlg::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
#if 0
	switch(nChar)
	{
	case VK_LEFT:
	case VK_NUMPAD4:
		m_remote_keys_bitmap &= ~RESEARCH_KIT_LEFT_BITMAP;
		break;

	case VK_RIGHT:
	case VK_NUMPAD6:
		m_remote_keys_bitmap &= ~RESEARCH_KIT_RIGHT_BITMAP;
		break;

	case VK_UP:
	case VK_NUMPAD8:
		m_remote_keys_bitmap &= ~RESEARCH_KIT_FORWARD_BITMAP;
		break;

	case VK_DOWN:
	case VK_NUMPAD2:
		m_remote_keys_bitmap &= ~RESEARCH_KIT_BACKWARD_BITMAP;
		break;

	default:
		break;
	}

	m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;

#ifdef REMOTE_COMMANDS_DBG
	Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
#endif
	CDialog::OnKeyUp(nChar, nRepCnt, nFlags);

}

//to enable keybord keys press translation
BOOL CRemotecontrolDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message==WM_KEYDOWN)
		OnKeyDown((UINT)pMsg->wParam,LOWORD(pMsg->lParam),HIWORD(pMsg->lParam));
	if(pMsg->message==WM_KEYUP)
		OnKeyUp((UINT)pMsg->wParam,LOWORD(pMsg->lParam),HIWORD(pMsg->lParam));
	
	return CDialog::PreTranslateMessage(pMsg);
}

//called when a new packet is received
LRESULT CRemotecontrolDlg::On_receive_packet(WPARAM wParam,LPARAM lParam)
{
	BYTE* packet = (BYTE*)lParam;
	
	wParam=NULL; //only to make the compiler happy
	if(packet)
		Analyze_packet(packet);//analize received packet
	return (TRUE);	
}

//analize the received packet
void CRemotecontrolDlg::Analyze_packet(byte* packet)
{
	static BOOL bIsFirstTime = FALSE;

	CString str=_T(""),tmp_str=_T("");
	int i=0;
	short short_value=0;
	long long_value=0;
//	CTime time = CTime::GetCurrentTime();

	m_dwLastReceivedDataTick = GetTickCount();

	if(Check_sum(packet,packet[LENGTH_INDEX]-1) == packet[packet[LENGTH_INDEX]-1])
	{
		switch(packet[ID_INDEX])
		{
		case RESEARCH_KIT_ID:
			switch(packet[3])
			{

			case RESEARCH_KIT_ROBOT_PC_ACK_ID:
				m_ack_type = packet[4];
				m_drive_motor_cmnd_end_reason = packet[5];

#ifdef DEMO_MODE
				if(m_ack_type == 2)
					m_demo_mode_state++;
#endif DEMO_MODE

                if( m_bIsCommandReceived == FALSE && m_ack_type == 1 )
				{
					m_dwLastCmndReceivedAck = m_dwLastReceivedDataTick;
					m_bIsCommandReceived = TRUE;
					m_bIsCommandFinished = FALSE;

					if( m_packet_editor_dlg_param3 == RESEARCH_KIT_DRIVE_MOV_STOP_TYPE )
							CalcCartesianCoor();
					TRACE( "Robot received the command\n" );		
				}
				
				if (m_bIsCommandReceived == TRUE && m_ack_type == 2 )
				{
					m_bIsGo = m_bIsTurnTo = m_bIsTurn = FALSE;
					
					CString strWork("The command is completed");

					switch( m_drive_motor_cmnd_end_reason )
					{
						case RESEARCH_KIT_DRIVE_MOV_BUMPER_EVENT:
                             strWork += ". Bumper impact";
						break;

						case RESEARCH_KIT_DRIVE_MOV_STAIR_EVENT:
                             strWork += ". Stair recognition";
						break;

						case RESEARCH_KIT_DRIVE_MOV_DIST:
						case RESEARCH_KIT_DRIVE_MOV_ANGLE:
							// Ok
                            if( m_bCartesTurn == FALSE && m_bCartesGoForward == FALSE &&
								                                         m_bCartesTheta == FALSE )
							{
                                m_bIsGoCartes = FALSE;                                 
							}// end of if( m_bCartesTurn == FALSE && m_bCartesGoForward == FALSE &&
						    if( m_bIsGoCartes == FALSE )
								 m_bWasRepeatMoveRobot = FALSE;
							strWork += " successfully";
						break;

						case RESEARCH_KIT_DRIVE_MOV_ULTRASOUND_EVENT:
                            strWork += ". Ultasound event";
						break;

                        default:
                            strWork += ". Unrecognized event";   
						break;

					}// end of switch( m_drive_motor_cmnd_end_reason )

					m_StaticStatus.SetWindowText(strWork);

					if( LastReceivedString.lCommandFromDevID != 0 &&
						  !(m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_DIST ||
                    		m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_ANGLE ))
			            AGVDriver_SendDesiredString( LastReceivedString.lCommandFromDevID, strWork );                       

					m_bIsCommandReceived = FALSE;
					m_bIsCommandFinished = TRUE;
//                    TRACE( strWork ); 

					CalcCartesianCoor();
					TRACE( "%s   X: %d   Y: %d   Theta: %d\n", strWork, m_lCurrentX, m_lCurrentY, m_sCurrentTheta );
				}// end of else if (m_bIsCommandFinished == FALSE  && m_ack_type == 2 )
				break;
				
			case RESEARCH_KIT_STOP_ID:
				TRACE( "Stop event received\n" );
				m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
				m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
#ifdef REMOTE_COMMANDS_DBG
				Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
				break;
			
			case RESEARCH_KIT_ROBOT_INFO_ID:
				{
					#define US_DATA_SIZE 20//size of ultrasound data in bytes
					byte ultra_sound_sensor_index=0;
					byte robot_telemetry_format_index=4;//indicates what telemetry was sent from the robot
					byte j=0;

					i = (robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_ARR_SIZE);

					//first add the RESEARCH_KIT_ROBOT_INF_ARR_SIZE bytes which represents
					//information about this packet
					tmp_str.Format(_T("%d "),(unsigned char)(packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PERIOD]));//period
					str += tmp_str;
					tmp_str.Format(_T("%d "),(unsigned char)(packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM1_BITMAP]));//info bitmap
					str += tmp_str;
					tmp_str.Format(_T("%d "),(unsigned char)(packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM2_BITMAP]));//info bitmap
					str += tmp_str;
					tmp_str.Format(_T("%d "),(unsigned char)(packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM3_BITMAP]));//info bitmap
					str += tmp_str;
					tmp_str.Format(_T("%d "),(unsigned char)(packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM4_BITMAP]));//info bitmap
                    str += tmp_str;
					
					//check if ultrasound data is received
					if((packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM1_BITMAP] & (0x01<<RESEARCH_KIT_US_INFO)))
					{
						for(j=(robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_ARR_SIZE);j<(robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_ARR_SIZE+US_DATA_SIZE-1);j+=2)
						{
							short_value = (signed short)(ntohs(*((signed short*)(packet+j)))); 
							tmp_str.Format(_T("%d "),short_value);
							str += tmp_str;
						}
						i += US_DATA_SIZE;
					}
					
					//check if odometer data is received
					if((packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM1_BITMAP] & (0x01<<RESEARCH_KIT_ODOMETER_INFO)))
					{
						m_sPrevHeading = m_sHeading;
						m_lPrevDistance = m_lDistance;
						m_sHeading = short_value = (signed short)(ntohs(*((signed short*)(packet+i)))); 
						tmp_str.Format(_T("%d "),short_value);
						str += tmp_str;
						i += 2;

						m_lDistance = long_value = (unsigned long)(ntohl(*((signed long*)(packet+i)))); 
						tmp_str.Format(_T("%d "),long_value);
						str += tmp_str;
						i += 4;

						long_value = (unsigned long)(ntohl(*((signed long*)(packet+i)))); 
						tmp_str.Format(_T("%d "),long_value);
						str += tmp_str;
						i += 4;

						long_value = (unsigned long)(ntohl(*((signed long*)(packet+i)))); 
						tmp_str.Format(_T("%d "),long_value);
						str += tmp_str;
						i += 4;

						char szWork[81];
                        if( m_lDistance != m_lPrevDistance || m_sHeading != m_sPrevHeading )
						{
#if 0
                 // No accuracy
							m_sCurrentTheta = m_sHeading - m_sHomeHeading;
							m_lCurrentX = (long)( m_lCurrentX + (double)( m_lDistance - m_lPrevDistance) * cos( Deg2Rad((double)m_sCurrentTheta )));
							m_lCurrentY = (long)( m_lCurrentY + (double)( m_lDistance - m_lPrevDistance) * sin( Deg2Rad((double)m_sCurrentTheta )));
							ViewCartesianCoor();
#endif
							if( m_lDistance != m_lPrevDistance )
							{
                               TRACE( "Distance counter: %d\n", m_lDistance );
                               SetDlgItemText(IDC_STATIC_DIST_COUNTER, ltoa(m_lDistance, szWork, 10) );
							}
								

							if( m_sHeading != m_sPrevHeading )
							{
                                TRACE( "Heading: %d\n", m_sHeading );
								SetDlgItemText(IDC_STATIC_HEADING, ltoa((long)m_sHeading, szWork, 10) );
							}
								

                             if( bIsFirstTime == FALSE )
							 {
								 bIsFirstTime = TRUE;


	                             m_lCurrentX = GetDlgItemInt(IDC_EDIT_X);
								 m_lCurrentY = GetDlgItemInt(IDC_EDIT_Y);
								 m_sCurrentTheta = GetDlgItemInt(IDC_EDIT_THETA);

								 m_sHomeHeading = m_sFirstHeading = m_sHeading;
  								 m_lHomeDistance = m_lFirstDistanceCount = m_lDistance;

								 m_sTheta_PositError = m_sHeadingCorrection = 0;

								 ViewCartesianCoor();
							 }// end of if( bIsFirstTime == FALSE )

						}// end of if( m_lDistance != m_lPrevDistance || m_sHeading != m_sPrevHeading )

					}// end of if((packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM1_BITMAP] & (0x01<<RESEARCH_KIT_ODOMETER_INFO)))
					if((packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM2_BITMAP] & (0x01<<RESEARCH_KIT_FRONT_PSD_INFO)))
					{
						static BOOL bStoped = FALSE;

						byte bytePSD = (byte)(packet[i]);
#if 0
						if( m_bIsHoming == TRUE )
						{
							if( m_sHeading == m_sPrevHeading )
    							m_iHomingHeadingCounter++;
							else
								m_iHomingHeadingCounter = 0;
						}// end of if( m_bIsHoming == TRUE )

						if( m_bIsHoming == TRUE && bytePSD > 107 && m_iHomingHeadingCounter > 20 )
						{
                            TRACE("Stair front PSD %d\n", bytePSD );
							m_bIsHoming = FALSE;
							m_iHomingHeadingCounter = 0;
							m_sFirstHeading = m_sHeading;
							m_lFirstDistanceCount = m_lDistance;
							MoveRobot( RESEARCH_KIT_DRIVE_MOV_STOP_TYPE, 0, 0 ); 
						}
#endif 
						i++;
					}// end of if((packet[robot_telemetry_format_index+RESEARCH_KIT_ROBOT_INF_PARAM2_BITMAP] & (0x01<<RESEARCH_KIT_FRONT_PSD_INFO)))

					//send all other data
					while(i<packet[LENGTH_INDEX]-1)
					{
						tmp_str.Format(_T("%d "),(unsigned char)(packet[i]));
						str += tmp_str;
						i++;
					}
					str += "\r\n";
					if(m_disp_wnd_dlg)
						m_disp_wnd_dlg->m_edit_cntrl.Add_line(str);
				}
				break;
				
			default:
				break;
			}
			break;

#ifdef ENABLE_DBG_MODE
		//a packet for showing a debug string which looks
		//like this:
		//first byte = START_BYTE
		//second byte is the length of the packet in bytes
		//third byte is the packet ID 
		//the next bytes are the string.
		//last byte is the check sum. 
		case DEBUG_STR_ID:
			for(i=3;i<packet[LENGTH_INDEX]-1;i++)
				str += packet[i];
			str += "\r\n";
			if(m_disp_wnd_dlg)
			{
				m_disp_wnd_dlg->m_edit_cntrl.Add_line(str);
			    TRACE(str);
			}
			break;

		case DEBUG_BUFFER_ID:
			switch(packet[3])
			{
			//a packet for showing a debug buffer of data
			//like this:
			//first byte = START_BYTE
			//second byte =  is the length of the packet in bytes
			//third byte = is the packet ID 
			//4'th byte = is the type of data in the buffer 
			//the next bytes are the data bytes (byte values).
			//last byte is the check sum. 
			case BYTE_TYPE:
				for(i=4;i<packet[LENGTH_INDEX]-1;i++)
				{
					tmp_str.Format(_T("%d "),(unsigned char)(packet[i]));
					str += tmp_str;
				}
				str += "\r\n";
				if(m_disp_wnd_dlg)
				{
					m_disp_wnd_dlg->m_edit_cntrl.Add_line(str);
					TRACE(str);
				}
				break;
					
			//a packet for showing a debug buffer of data
			//like this:
			//first byte = START_BYTE
			//second byte =  is the length of the packet in bytes
			//third byte = is the packet ID 
			//4'th byte = is the type of data in the buffer 
			//the next bytes are the data bytes (short type values)
			//last byte is the check sum. 
			case SHORT_TYPE:
				for(i=4;i<packet[LENGTH_INDEX]-1;i+=2)
				{
					short_value = (signed short)(ntohs(*((signed short*)(packet+i)))); 
					tmp_str.Format(_T("%d "),short_value);
					str += tmp_str;
				}
				str += "\r\n";
				if(m_disp_wnd_dlg)
				{
					m_disp_wnd_dlg->m_edit_cntrl.Add_line(str);
					TRACE(str);
				}
				break;
				
			//a packet for showing a debug buffer of data
			//like this:
			//first byte = START_BYTE
			//second byte =  is the length of the packet in bytes
			//third byte = is the packet ID 
			//4'th byte = is the type of data in the buffer 
			//the next bytes are the data bytes (long type values)
			//last byte is the check sum. 
			case LONG_TYPE:
				for(i=4;i<packet[LENGTH_INDEX]-1;i+=4)
				{
					long_value = (signed long)(ntohl(*((signed long*)(packet+i)))); 
					tmp_str.Format(_T("%d "),long_value);
					str += tmp_str;
				}
				str += "\r\n";
				if(m_disp_wnd_dlg)
				{
                   m_disp_wnd_dlg->m_edit_cntrl.Add_line(str);
				   TRACE(str);
				}
					
				break;

			default:
				break;
			}
			break;
#endif ENABLE_DBG_MODE

		default:
			break;
		}
	}
}// end of void CRemotecontrolDlg::Analyze_packet(byte* packet)

#ifdef REMOTE_COMMANDS_DBG
void CRemotecontrolDlg::Print_remote_commands()
{
	CString str = _T("BUTTONS: ");

	if(m_remote_keys_bitmap & RESEARCH_KIT_FORWARD_BITMAP)
		str += "forward ";
	if(m_remote_keys_bitmap & RESEARCH_KIT_BACKWARD_BITMAP)
		str += "backward ";
	if(m_remote_keys_bitmap & RESEARCH_KIT_LEFT_BITMAP)
		str += "left ";
	if(m_remote_keys_bitmap & RESEARCH_KIT_RIGHT_BITMAP)
		str += "right ";
	TRACE("%s\n",str);
}
#endif REMOTE_COMMANDS_DBG

//user_command - indicates if packet is beeing sent because of user interaction through the packet editor dialog
void CRemotecontrolDlg::Transmit_packet(BOOL user_command, byte packet_id) 
{
	static byte packet[MAX_PACKET_LENGTH];
	static byte i=0;
	byte packet_id_2_send = ((user_command) ? (m_packet_editor_dlg_param1) : (packet_id));
	BOOL send_packet=FALSE;
	
	switch(packet_id_2_send)
	{
	case RESEARCH_KIT_NAVIGATION_ID:
		if(user_command)
		{
			m_halt_communication_count = -1;
			m_remote_keys_bitmap &= STOP_MOVEMENT_BITMAP;
			m_remote_keys_bitmap = m_packet_editor_dlg_param2;
			m_send_packet_id = RESEARCH_KIT_NAVIGATION_ID;
			m_keyboard_nav_cntrl = FALSE;
		}
		else
		{
			send_packet = TRUE;
			packet[PREAMBLE_INDEX] = START_BYTE;
			packet[LENGTH_INDEX] = 6;
			packet[ID_INDEX] = RESEARCH_KIT_ID;
			packet[3] = RESEARCH_KIT_NAVIGATION_ID;
			packet[4] = m_remote_keys_bitmap;
			packet[5] = Check_sum(packet,packet[LENGTH_INDEX]-1);
		}
		break;

	case RESEARCH_KIT_ROBOT_INFO_ID:
		{
			send_packet = TRUE;
			packet[PREAMBLE_INDEX] = START_BYTE;
			packet[LENGTH_INDEX] = 10;
			packet[ID_INDEX] = RESEARCH_KIT_ID;
			packet[3] = m_packet_editor_dlg_param1;
			packet[4] = m_packet_editor_dlg_param2;
			packet[5] = m_packet_editor_dlg_param3;
			packet[6] = m_packet_editor_dlg_param4;
			packet[7] = (byte)m_packet_editor_dlg_param5;
            packet[8] = (byte)m_packet_editor_dlg_param6;
			packet[9] = Check_sum(packet,packet[LENGTH_INDEX]-1);
		}
		break;

	case RESEARCH_KIT_ROBOT_BUZZER_ID:
		{
			send_packet = TRUE;
			packet[PREAMBLE_INDEX] = START_BYTE;
			packet[LENGTH_INDEX] = 7;
			packet[ID_INDEX] = RESEARCH_KIT_ID;
			packet[3] = m_packet_editor_dlg_param1;
			packet[4] = m_packet_editor_dlg_param2;
			packet[5] = m_packet_editor_dlg_param3;
			packet[6] = Check_sum(packet,packet[LENGTH_INDEX]-1);
		}
		break;

	case RESEARCH_KIT_DUMMY_ID:
		{
			send_packet = TRUE;
			packet[PREAMBLE_INDEX] = START_BYTE;
			packet[LENGTH_INDEX] = 5;
			packet[ID_INDEX] = RESEARCH_KIT_ID;
			packet[3] = m_packet_editor_dlg_param1;
			packet[4] = Check_sum(packet,packet[LENGTH_INDEX]-1);
		}
		break;

	case RESEARCH_KIT_END_PROG_MODE:
		{
			send_packet = TRUE;
			packet[PREAMBLE_INDEX] = START_BYTE;
			packet[LENGTH_INDEX] = 5;
			packet[ID_INDEX] = RESEARCH_KIT_ID;
			packet[3] = m_packet_editor_dlg_param1;
			packet[4] = Check_sum(packet,packet[LENGTH_INDEX]-1);
		}
		break;

	case RESEARCH_KIT_ROBOT_MOTOR_ID:
		{
			send_packet = TRUE;
			packet[PREAMBLE_INDEX] = START_BYTE;
			packet[ID_INDEX] = RESEARCH_KIT_ID;
			packet[3] = m_packet_editor_dlg_param1;
			packet[4] = m_packet_editor_dlg_param2;
			switch(packet[4])
			{
			case RESEARCH_KIT_SUCTION_MOTOR:
				packet[LENGTH_INDEX] = 7;
				packet[5] = m_packet_editor_dlg_param3;
				packet[packet[LENGTH_INDEX]-1] = Check_sum(packet,packet[LENGTH_INDEX]-1);
				break;

			case RESEARCH_KIT_BRUSH_MOTOR:
				packet[LENGTH_INDEX] = 8;
				packet[5] = m_packet_editor_dlg_param3;
				packet[6] = m_packet_editor_dlg_param4;
				packet[packet[LENGTH_INDEX]-1] = Check_sum(packet,packet[LENGTH_INDEX]-1);
				break;

			case RESEARCH_KIT_DRIVE_MOTOR:
				switch(m_packet_editor_dlg_param3)
				{
					case RESEARCH_KIT_DRIVE_MOV_HEAD_TYPE:
						packet[LENGTH_INDEX] = 14;
						packet[5] = m_packet_editor_dlg_param3;
						packet[6] = m_packet_editor_dlg_param4;
						packet[7] = (byte)(m_packet_editor_dlg_param5 >> 8);
						packet[8] = (byte)(m_packet_editor_dlg_param5 & 0x00ff);
						packet[9] = (byte)(m_packet_editor_dlg_param6 >> 8);
						packet[10] = (byte)(m_packet_editor_dlg_param6 & 0x00ff);
						packet[11] = (byte)(m_packet_editor_dlg_param7 >> 8);
						packet[12] = (byte)(m_packet_editor_dlg_param7 & 0x00ff);
						break;
						
					case RESEARCH_KIT_DRIVE_MOV_TURN_TO_TYPE:
						packet[LENGTH_INDEX] = 10;
						packet[5] = m_packet_editor_dlg_param3;
						packet[6] = m_packet_editor_dlg_param4;
						packet[7] = (byte)(m_packet_editor_dlg_param5 >> 8);
						packet[8] = (byte)(m_packet_editor_dlg_param5 & 0x00ff);
						break;

					default:
					packet[LENGTH_INDEX] = 9;
					packet[5] = m_packet_editor_dlg_param3;
					packet[6] = m_packet_editor_dlg_param4;
					packet[7] = (byte)m_packet_editor_dlg_param5;
					packet[8] = (byte)m_packet_editor_dlg_param6;
					break;

				}// end of switch(m_packet_editor_dlg_param3)
				packet[packet[LENGTH_INDEX]-1] = Check_sum(packet,packet[LENGTH_INDEX]-1);
				break;

			case RESEARCH_KIT_ELEVATION_MOTOR:
				packet[LENGTH_INDEX] = 7;
				packet[5] = m_packet_editor_dlg_param3;
				packet[packet[LENGTH_INDEX]-1] = Check_sum(packet,packet[LENGTH_INDEX]-1);
				break;

			default:
				packet[LENGTH_INDEX] = 0;
				break;
			}
		}
		break;
		
	default:
		break;
	}
	
	if(send_packet)
	{
		m_last_comm_count = 0;
		for(i=0; i<packet[LENGTH_INDEX]; i++)
			m_p_com_thread->Send_char(packet[i]);
	}
	
}

void CRemotecontrolDlg::OnSettingsPacketeditor() 
{
	if(!m_packet_editor_dlg)
	{
		//dialog does not exist so we should create it
		m_packet_editor_dlg = new CPacketEditorDlg(this);
		m_packet_editor_dlg->Create(IDD_PACKET_EDITOR_DIALOG);
	}
	if(m_packet_editor_dlg)
		m_packet_editor_dlg->ShowWindow(SW_SHOW);
}

void CRemotecontrolDlg::OnToolsDisplayWindow() 
{
	if(!m_disp_wnd_dlg)
	{
		//dialog does not exist so we should create it
		m_disp_wnd_dlg = new CDisplayWndDlg(this);
		m_disp_wnd_dlg->Create(IDD_DIALOG_DISPLAY_WND);
	}
	if(m_disp_wnd_dlg)
		m_disp_wnd_dlg->ShowWindow(SW_SHOW);
}

void CRemotecontrolDlg::OnAppAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

BOOL CRemotecontrolDlg::Executer()
{
	BOOL bRet = FALSE;

	byte byteSpeed;
 
	if( m_bEndProgramMode == TRUE )
	{
		m_bEndProgramMode = FALSE;
		m_packet_editor_dlg_param1 = RESEARCH_KIT_END_PROG_MODE;
		Transmit_packet(FALSE,RESEARCH_KIT_END_PROG_MODE);
		return TRUE;
	}

	if( m_bIsCommandFinished == FALSE && ( m_bIsGoPath == TRUE || m_bIsGoCartes == TRUE ))
	{
		m_iCommandFinishedDelayCounter = 0;

		// Workaround of missing of movement start and  missing of completion acknowledge.
		if( m_bIsCommandReceived == TRUE && m_dwTimerTick - m_dwLastCmndReceivedAck > 2000 &&
			   IsRobotMoved() == FALSE )
		{
            TRACE("I did not receive completion acknowledge.");
#ifdef _DEBUG
            m_Speaker.Speak("I did not receive completion acknowledge." );
#endif
			RepeatMoveRobot(); 
            return TRUE;
		}
	}
	else 
	{
        m_iCommandFinishedDelayCounter++;
	}
           
    if( m_bIsGoCartes == TRUE && m_bIsCommandFinished == TRUE && m_iCommandFinishedDelayCounter > 0 )
	{

		if( m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_DIST || 
			    m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_ANGLE )
		{
			m_iRepeatMoveRobotCounter = 0;
			if( m_bCartesTurn == TRUE )
			{
				 m_bCartesTurn = FALSE;

				 if( m_sCartesTurn > 180 )
					 m_sCartesTurn = -360 + m_sCartesTurn;
				 else if( m_sCartesTurn < -180 )
					 m_sCartesTurn = 360 + m_sCartesTurn;

					 if( m_sCartesTurn < 0 )
						byteSpeed = 60;
					 else
						byteSpeed = 120;

					 m_sFirstHeading = m_sHeading;
					 m_lFirstDistanceCount = m_lDistance;
					 bRet = TRUE;
					 MoveRobot( RESEARCH_KIT_DRIVE_MOV_TURN_TYPE, byteSpeed, abs(m_sCartesTurn) );
				 if( m_lCartesGoForward > 0 )
					m_bCartesGoForward = TRUE;
				 else if( m_sCartesTheta != sNO_TURN )
					 m_bCartesTheta = TRUE;
				 else
				 {
					 m_bCartesTheta = FALSE;
				 }
					 
			}// end of if( m_bCartesTurn == TRUE )
			else if ( m_bCartesGoForward == TRUE )
			{
				m_bCartesGoForward = FALSE;
				m_sFirstHeading = m_sHeading;
				m_lFirstDistanceCount = m_lDistance;
				bRet = TRUE;
				MoveRobot( RESEARCH_KIT_DRIVE_MOV_HEAD_TYPE, m_uncSpeed, sNO_TURN, (unsigned short) m_lCartesGoForward, m_sUltraSoundThreshold );
				if( m_sCartesTheta != sNO_TURN  )
					 m_bCartesTheta = TRUE;
				 else
				 {
					 m_bCartesTheta = FALSE;
				 }
			}
			else if ( m_bCartesTheta == TRUE )
			{
				 m_sCartesTheta = m_sCartesTheta - m_sCurrentTheta;

				 if( m_sCartesTheta > 180 )
					 m_sCartesTheta = -360 + m_sCartesTheta;
				 else if( m_sCartesTheta < -180 )
					 m_sCartesTheta = 360 + m_sCartesTheta;

				 if( m_sCartesTheta != 0 )
				 {	
					 if( m_sCartesTheta < 0 )
						byteSpeed = 60;
					 else
						byteSpeed = 120;

					 m_bCartesTheta = FALSE;
	 				 m_sFirstHeading = m_sHeading;
					 m_lFirstDistanceCount = m_lDistance;
					 bRet = TRUE;
					 MoveRobot( RESEARCH_KIT_DRIVE_MOV_TURN_TYPE, byteSpeed, (short)abs(m_sCartesTheta) );    
				 }// end of if( m_sCartesTheta != 0 )
				 else
				 {
					 m_bCartesTheta = FALSE;
					 m_bIsGoCartes = FALSE;
				 }
			}
		}// end of if( m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_DIST || 
		
	}// end of if( m_bIsGoCartes == TRUE && m_bIsCommandFinished == TRUE && m_iCommandFinishedDelayCounter > 1 )

	if( m_bIsCommandFinished == TRUE && m_bIsGoCartes == TRUE &&
		!(m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_DIST || 
			    m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_ANGLE ))
	{
		if( m_bWasRepeatMoveRobot == FALSE )
		{
				static DWORD dwFirstTimerTick;
				if( m_iRepeatMoveRobotCounter == 0 )
				{
					if( m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_BUMPER_EVENT &&
					    m_bWasFalseBumperEvent == FALSE && IsRobotMoved() == FALSE )
					{
						TRACE( "False bumper event\n" );
#ifdef _DEBUG
						m_Speaker.Speak("False bumper event");   
#endif
						m_bWasFalseBumperEvent = TRUE;
                        RepeatMoveRobot(); 
						return FALSE;
					}
					else
						m_bWasFalseBumperEvent = FALSE;

					m_iRepeatMoveRobotCounter++;

					TCHAR szWork[256];
					CString strToSpeak;
					CString strVoiceFilePath;
					GetPrivateProfileString(cszVoiceSection, "DelayAfterObstacle_file", "", 
										 szWork, sizeof(szWork), m_strAppLanguageFilePath);
					if( szWork[0] != '\0' )
					{
					   strVoiceFilePath = m_szExecDir + (CString)"Voice\\" + (CString)szWork;
					   PlayFile( strVoiceFilePath ); 
					}// end of if( szWork[0] != '\0' )
					else
					{
						GetPrivateProfileString(cszVoiceSection, "DelayAfterObstacle_text", "", 
										 szWork, sizeof(szWork), m_strAppLanguageFilePath);
						if( szWork[0] != '\0' )
						{
							strToSpeak.Format(szWork, m_iDelayAfterObstacle_ms / 1000 );
							strToSpeak.MakeLower();
							if( m_Speaker.GetIsSpeaking() )
								m_Speaker.StopSpeaking();
							m_Speaker.Speak(strToSpeak);   
						}
					}
				}// end of if( m_iRepeatMoveRobotCounter == 0 )

				if( m_Speaker.GetIsSpeaking() )
					return bRet;
				
				m_dwTimerTick = GetTickCount();
				if( m_iRepeatMoveRobotCounter == 1 )
				{
					dwFirstTimerTick = m_dwTimerTick;
				}
					
				m_iRepeatMoveRobotCounter++;
				DWORD dwTime = m_dwTimerTick - dwFirstTimerTick;

				if( dwTime > m_iDelayAfterObstacle_ms - 50 )
				{
					TRACE( "Delay (ms) before RepeatMoveRobot: %d\n", dwTime );
					m_iRepeatMoveRobotCounter = 0;
					RepeatMoveRobot();
				}

		}// end of if( m_bWasRepeatMoveRobot == FALSE )
		else
		{
			m_bIsGoPath = TRUE;
		}

		return FALSE;
	}// end of if( m_bIsCommandFinished == TRUE && !(m_drive_motor_cmnd_end_reason == RESEARCH_KIT_DRIVE_MOV_DIST || 

	if( m_bIsGoPath == TRUE && m_bIsGoCartes == FALSE && m_bIsCommandFinished == TRUE && m_bIsPause == FALSE)
         GoAlongPath();

       return bRet;
}// end of BOOL CRemotecontrolDlg::Executer()

BOOL CRemotecontrolDlg::IsRobotMoved()
{
	const long lTolerance = 1;
	if( abs( m_sHeading - m_sFirstHeading ) > lTolerance  || 
		        abs( m_lDistance - m_lFirstDistanceCount ) > lTolerance )
		return TRUE;
	else
		return FALSE;
}// end of BOOL CRemotecontrolDlg::IsRobotMoved()

void CRemotecontrolDlg::OnButtonGo()
{
	UpdateData(TRUE);
	long lRequiredDistance = atol(m_strDistance);

	m_sUltraSoundThreshold = (short)atol( m_strUltraSoundThreshold );
	
	CString strSpeed;
	m_ComboSpeed.GetWindowText(strSpeed);
	m_uncSpeed = atoi(strSpeed);

	m_bIsGo = TRUE;
	m_bIsTurnTo = m_bIsTurn = m_bIsGoPath = FALSE;

	m_sFirstHeading = m_sHeading;
	m_lFirstDistanceCount = m_lDistance;
    m_lStopDistanceCount = m_lDistance + lRequiredDistance;
	MoveRobot( RESEARCH_KIT_DRIVE_MOV_HEAD_TYPE, m_uncSpeed, 360, (unsigned short) lRequiredDistance, m_sUltraSoundThreshold );

}// end of void CRemotecontrolDlg::OnButtonGo()

void CRemotecontrolDlg::ClearMovementFlags()
{
	m_bIsGo = m_bIsTurnTo = m_bIsTurn = m_bIsGoPath = FALSE;

	m_bIsCommandReceived = FALSE;
	m_bIsCommandFinished = TRUE;
	m_iCommandFinishedDelayCounter = 0;

	m_drive_motor_cmnd_end_reason = RESEARCH_KIT_DRIVE_MOV_DIST;
	m_ack_type = 2;
}// end of void CRemotecontrolDlg::ClearMovementFlags()


void CRemotecontrolDlg::MoveRobot( byte uncMovementType, byte uncSpeed, short sHeading, 
		               unsigned short usDistance, short sUltraSoundThreshold )

{
	m_packet_editor_dlg_param1 = RESEARCH_KIT_ROBOT_MOTOR_ID;
	m_packet_editor_dlg_param2 = RESEARCH_KIT_DRIVE_MOTOR;
	m_packet_editor_dlg_param3 = uncMovementType;
	m_packet_editor_dlg_param4 = uncSpeed; // velocity: 0 - 19
	m_packet_editor_dlg_param5 = sHeading;
    m_packet_editor_dlg_param6 = usDistance;
	m_packet_editor_dlg_param7 = sUltraSoundThreshold;

	m_bIsCommandReceived = FALSE;
	m_bIsCommandFinished = FALSE;

#if 0
	if( m_packet_editor_dlg_param3 == RESEARCH_KIT_DRIVE_MOV_TURN_TYPE )
	{
		m_packet_editor_dlg_param5 += sHeading / 90;
		m_packet_editor_dlg_param5 = (m_packet_editor_dlg_param5 > 180 )?180:m_packet_editor_dlg_param5;
	}
#endif
    m_StaticStatus.SetWindowText("");	
	TRACE( "Move Robot. Type: %d   Speed:  %d   Heading: %d   Distance: %d  UltraSoundThreshold: %d\n", 
		 uncMovementType, uncSpeed, m_packet_editor_dlg_param5, usDistance, sUltraSoundThreshold );
	Transmit_packet(FALSE,RESEARCH_KIT_ROBOT_MOTOR_ID);  

}// end of void CRemotecontrolDlg::MoveRobot( byte uncMovementType, byte uncSpeed, byte uncHeading )

void CRemotecontrolDlg::RequestForMotionInfo( BOOL bIsRequest )
{
	m_packet_editor_dlg_param1 = RESEARCH_KIT_ROBOT_INFO_ID;
    
    if( bIsRequest == TRUE  )
	{
		m_packet_editor_dlg_param2 = 1;   // Messages rate ( 50 msec steps )
		m_packet_editor_dlg_param3 = 1 << RESEARCH_KIT_ODOMETER_INFO;  // Odometer
	}
	else
	{
		m_packet_editor_dlg_param2 = 0; 
		m_packet_editor_dlg_param3 = 0;
	}

	m_packet_editor_dlg_param4 = 0;
	m_packet_editor_dlg_param5 = 0;    
	m_packet_editor_dlg_param6 = 0;
	Transmit_packet(FALSE,RESEARCH_KIT_ROBOT_INFO_ID);  

}// end of void CRemotecontrolDlg::RequestForMotionInfo()

void CRemotecontrolDlg::OnButtonSetHome() 
{
    UpdateData(TRUE);

	if( m_strEditTheta == cszANY )
	{
		m_ByUser.SetCheck( BST_CHECKED );
		m_Any.SetCheck( BST_UNCHECKED );
		OnRadioByUser();
       AfxMessageBox(cszSetTheta);
	   return;
	}
	m_lCurrentX = atol( m_strEditX );
	m_lCurrentY = atol( m_strEditY );
	m_sCurrentTheta = atol( m_strEditTheta );

	m_sHomeHeading = m_sFirstHeading = m_sHeading;
  	m_lHomeDistance = m_lFirstDistanceCount = m_lDistance;

	m_sTheta_PositError = m_sHeadingCorrection = 0;

    ViewCartesianCoor();

}// end of void CRemotecontrolDlg::OnButtonSetHome() 

void CRemotecontrolDlg::ViewCartesianCoor()
{
	char szWork[81];

    SetDlgItemText(IDC_STATIC_X, ltoa(m_lCurrentX, szWork, 10) );
	SetDlgItemText(IDC_STATIC_Y, ltoa(m_lCurrentY, szWork, 10) );
	SetDlgItemText(IDC_STATIC_THETA, ltoa(m_sCurrentTheta, szWork, 10) );

}// end of void CRemotecontrolDlg::ViewCartesianCoor()

#if 0
   // Old implementation
void CRemotecontrolDlg::CalcCartesianCoor()
{
	m_sCurrentTheta = m_sHeading - m_sHomeHeading + m_sHeadingCorrection;

	m_sCurrentTheta = ( m_sCurrentTheta >= 0 )? m_sCurrentTheta : m_sCurrentTheta + 360; 

	m_lCurrentX = (long)( m_lCurrentX + (double)( m_lDistance - m_lFirstDistanceCount) * cos( Deg2Rad((double)m_sCurrentTheta )));
	m_lCurrentY = (long)( m_lCurrentY + (double)( m_lDistance - m_lFirstDistanceCount) * sin( Deg2Rad((double)m_sCurrentTheta )));

	ViewCartesianCoor();

}// end of void CRemotecontrolDlg::CalcCartesianCoor()
#endif

void CRemotecontrolDlg::CalcCartesianCoor()
{
    TRACE( "Distance counter, Heading: %d %d\n", m_lDistance, m_sHeading );

	m_sCurrentTheta = m_sHeading - m_sHomeHeading + m_sHeadingCorrection;
	m_sCurrentTheta += m_sTheta_PositError;
	m_sCurrentTheta = ( m_sCurrentTheta >= 0 )? m_sCurrentTheta : m_sCurrentTheta + 360; 
	m_sCurrentTheta = ( m_sCurrentTheta > 360 )? m_sCurrentTheta - 360 : m_sCurrentTheta; 
	if( m_sTheta_PositError != 0 )
	{
		m_sHeadingCorrection += m_sTheta_PositError;
		m_sHeadingCorrection = m_sHeadingCorrection % 360;

	}
	m_sTheta_PositError = 0;

	m_lCurrentX = (long)( m_lCurrentX + (double)( m_lDistance - m_lFirstDistanceCount) * cos( Deg2Rad((double)m_sCurrentTheta )));

    m_lCurrentY = (long)( m_lCurrentY + (double)( m_lDistance - m_lFirstDistanceCount) * sin( Deg2Rad((double)m_sCurrentTheta )));

	ViewCartesianCoor();
}// end of void CRemotecontrolDlg::CalcCartesianCoor()

void CRemotecontrolDlg::OnButtonTurnTo() 
{
	UpdateData(TRUE);
	m_bIsGo = m_bIsTurn = m_bIsGoPath = FALSE;
	m_bIsTurnTo = TRUE;

	m_lRequiredAngle = atol( m_strTurnTo );

	m_sFirstHeading = m_sHeading;
	m_lFirstDistanceCount = m_lDistance;

    m_lStopAngleCount = m_sFirstHeading + m_lRequiredAngle;
    m_lStopAngleCount = ( m_lStopAngleCount > 360 )?(m_lStopAngleCount - 360 ) : m_lStopAngleCount;
	MoveRobot( RESEARCH_KIT_DRIVE_MOV_TURN_TO_TYPE, 0, (unsigned short )m_lStopAngleCount );

}// end of void CRemotecontrolDlg::OnButtonTurnTo()

void CRemotecontrolDlg::OnButtonTurn() 
{
   UpdateData(TRUE);
   m_bIsGo = m_bIsTurnTo = m_bIsGoPath = FALSE;
   m_bIsTurn = TRUE;

	m_sFirstHeading = m_sHeading;
	m_lFirstDistanceCount = m_lDistance;


	CString strSpeed;
	m_ComboSpeed.GetWindowText(strSpeed);
	m_uncSpeed = atoi(strSpeed);

	m_lRequiredAngle = atol( m_strTurn );

	if( m_lRequiredAngle <= 0 || m_lRequiredAngle > 180 )
               AfxMessageBox( "Improper turn angle. The proper range is 1 to 180 degree.",MB_ICONERROR | MB_OK );
    else
		MoveRobot( RESEARCH_KIT_DRIVE_MOV_TURN_TYPE, m_uncSpeed, (unsigned short )m_lRequiredAngle );

}// end of void CRemotecontrolDlg::OnButtonTurn()


void CRemotecontrolDlg::OnButtonClear() 
{
	m_strEditX = "0";
	m_strEditY = "0";
    if( m_strEditTheta == cszANY )
	{
		m_ByUser.SetCheck( BST_CHECKED );
		m_Any.SetCheck( BST_UNCHECKED );
		OnRadioByUser();
	}
	m_strEditTheta = "0";
    UpdateData(FALSE);
}// end of void CRemotecontrolDlg::OnButtonClear() 

bool ComparePositions(const Position &a, const Position &b)
{
   return a.lNumber < b.lNumber;
}

void CRemotecontrolDlg::FillInGridPositCombo()
{
	CString strPositArray(" ");
	CString strWork;

	VECT_POSIT::iterator vi;
	for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
	{
        Position &Posit = *vi;
	    strWork.Format("%d", Posit.lNumber );
        strPositArray = strPositArray + "|" + strWork;
	}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )

	m_ListPosit.SetColComboList(1, strPositArray);

}// end of void CRemotecontrolDlg::FillInGridPositCombo()

void CRemotecontrolDlg::OnButtonTeach() 
{
	CString strPositNumber;
	Position SomePosition;

	UpdateData(TRUE);
	m_ComboPositNumber.GetWindowText(strPositNumber);
	SomePosition.lNumber = atol(strPositNumber);
	if( SomePosition.lNumber <= 0 )
	{
        AfxMessageBox( "Invalid position number!" ); 
		return;
	}// end of if( SomePosition.lNumber <= 0 )
			
	m_bIsPathChanged = TRUE;
    SomePosition.lX = atol(m_strEditX);
	SomePosition.lY = atol(m_strEditY);

    if( m_strEditTheta == cszANY )
        SomePosition.sTheta = 360; 
	else
		SomePosition.sTheta = atol(m_strEditTheta);

//    SomePosition.sTheta = (SomePosition.sTheta == 0 ) ? sNO_TURN : SomePosition.lTheta;

	VECT_POSIT::iterator vi;
	for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
	{
        Position &Posit = *vi;
		if( Posit.lNumber == SomePosition.lNumber )
		{
            Posit = SomePosition;
			return;
		}// end of if( Posit.lNumber == lPositNumber )
	}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )

	m_PositArray.push_back(SomePosition);

	if( m_ComboPositNumber.FindStringExact(-1, strPositNumber) == CB_ERR  )
	    m_ComboPositNumber.AddString(strPositNumber);

	sort(m_PositArray.begin(), m_PositArray.end(), ComparePositions );

	FillInGridPositCombo();
	
}// end of void CRemotecontrolDlg::OnButtonTeach() 

void CRemotecontrolDlg::GoToCartes( long lX, long lY, short sTheta, byte uncSpeed )
{
	m_lLastXCmnd = lX;
    m_lLastYCmnd = lY;
	m_sLastTheta = sTheta;
    m_uncLastSpeed =  uncSpeed;

	m_drive_motor_cmnd_end_reason = RESEARCH_KIT_DRIVE_MOV_DIST;

	long lDeltaX = lX - m_lCurrentX;
	long lDeltaY = lY - m_lCurrentY;

    TRACE( "\nGo to position: X: %d   Y:  %d   Theta: %d   Speed: %d\n", 
		 lX, lY, sTheta, uncSpeed );

	short sTurn = Rad2Deg(atan2( lDeltaY, lDeltaX ));
	
	m_lCartesGoForward = (long)(sqrt( (double)( lDeltaX*lDeltaX + lDeltaY*lDeltaY )) + 0.5);

	m_sCartesTheta = sTheta;

	m_uncSpeed = uncSpeed;

	m_bCartesGoForward = m_bCartesTurn = m_bCartesTheta = FALSE;

	m_bIsGo = m_bIsTurnTo = m_bIsTurn = FALSE;

	m_bIsCommandFinished = TRUE;

	m_sCartesTurn = sTurn - m_sCurrentTheta;
	if( m_sCartesTurn != 0 )
	{
       m_bCartesTurn = TRUE;
       m_bIsGoCartes = TRUE;      
	}
	else if( m_lCartesGoForward > 0 )
	{
        m_bCartesGoForward = TRUE;
		m_bIsGoCartes = TRUE;
	}
    else if( m_sCartesTheta != sNO_TURN )
	{
       m_bCartesTheta = TRUE;
	   m_bIsGoCartes = TRUE;
	}
}// end of void CRemotecontrolDlg::GoToCartes( long lX, long lY, unsigned short usTheta, byte uncSpeed )

void CRemotecontrolDlg::OnButtonGoCartes() 
{
	CString strSpeed;
	CString strPositNumber;
	long lPositNumber;

	UpdateData(TRUE);

	ClearMovementFlags();

	m_ComboSpeed.GetWindowText(strSpeed);
	byte uncSpeed = atoi(strSpeed);

	m_ComboPositNumber.GetWindowText(strPositNumber);
	lPositNumber = atol(strPositNumber);

	VECT_POSIT::iterator vi;
	for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
	{
        Position &Posit = *vi;
		if( Posit.lNumber == lPositNumber )
		{
            GoToCartes( Posit.lX, Posit.lY, Posit.sTheta, uncSpeed );
			return;
		}// end of if( Posit.lNumber == lPositNumber )
	}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
    
	AfxMessageBox( "Unknown position!" );

}// end of void CRemotecontrolDlg::OnButtonGoCartes() 

void CRemotecontrolDlg::OnButtonLocalize() 
{
	UpdateData(TRUE);

	if( m_strEditTheta == cszANY )
	{
	   m_ByUser.SetCheck( BST_CHECKED );
	   m_Any.SetCheck( BST_UNCHECKED );
	   OnRadioByUser();
       AfxMessageBox( cszSetTheta );
	   return;
	}

	Localize();

}// end of void CRemotecontrolDlg::OnButtonLocalize() 

void CRemotecontrolDlg::Localize()
{
	m_lPrevX = m_lCurrentX;
	m_lPrevY = m_lCurrentY;
	m_sPrevTheta = m_sCurrentTheta;


	m_lCurrentX = atol( m_strEditX );
	m_lCurrentY = atol( m_strEditY );
	m_sCurrentTheta = atol( m_strEditTheta );

	m_sCurrentTheta = ( m_sCurrentTheta >= 0 )? m_sCurrentTheta : m_sCurrentTheta + 360; 
	m_sCurrentTheta = ( m_sCurrentTheta >= 360 )? m_sCurrentTheta - 360 : m_sCurrentTheta; 

	m_sTheta_PositError = m_sCurrentTheta - m_sPrevTheta;

    ViewCartesianCoor();

}// end of void CRemotecontrolDlg::Localize()

void CRemotecontrolDlg::OnButtonDeletePosit() 
{
	CString strPositNumber;
	long lPositNumber;

	m_ComboPositNumber.GetWindowText(strPositNumber);
	lPositNumber = atol(strPositNumber);

	VECT_POSIT::iterator vi;
	for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
	{
        Position &Posit = *vi;
		if( Posit.lNumber == lPositNumber )
		{
            m_PositArray.erase( vi );
			int iIndex = m_ComboPositNumber.FindStringExact(-1, strPositNumber);
			if( iIndex != CB_ERR  )
				m_ComboPositNumber.DeleteString(iIndex);
            m_ComboPositNumber.SetWindowText("");     
			FillInGridPositCombo();
			m_bIsPathChanged = TRUE;
   			return;
		}// end of if( Posit.lNumber == lPositNumber )
	}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )

	AfxMessageBox( "Unknown position!" );

}// end of void CRemotecontrolDlg::OnButtonDeletePosit() 

void CRemotecontrolDlg::OnOpenFile() 
{
	TCHAR szFileDialogFilter[] = "(*.apf)|*.apf||";

	CFileDialog filedialog(TRUE, _T("apf"),NULL,OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,szFileDialogFilter);
	filedialog.m_ofn.lpstrInitialDir = m_szExecDir;
	if(filedialog.DoModal() == IDOK)
	{		
        m_strPathFillFullName = filedialog.GetPathName();   
		OpenPathsFile( m_strPathFillFullName );
	}// end of if(filedialog.DoModal() == IDOK)
	
}// end of void CRemotecontrolDlg::OnOpenFile()


void CRemotecontrolDlg::OpenPathsFile( CString strPathsFile )
{
	TCHAR szSection[41] = "Positions";
	TCHAR szEntry[41];
	TCHAR szWork[1025] = "";

	CString strToken;

	int iCounter = 1;

	if( strPathsFile.IsEmpty() == 0 )
	{
		m_PositArray.clear();
		m_PathArray.clear();
		// Get positions
		do
		{
			_stprintf(szEntry,"Pos_%d", iCounter );
			GetPrivateProfileString(szSection, szEntry, "", szWork, sizeof(szWork), strPathsFile);
			if( szWork[0] != '\0' )
			{
			   Position Posit;
               CTokenizer tok( szWork, _T(" ,"));
			   if( tok.Next( strToken ))
			   {
                   Posit.lNumber = atol(strToken);
				   if( tok.Next( strToken ))
				   {
					   Posit.lX = atol(strToken);
					   if( tok.Next( strToken ))
					   {
						  Posit.lY = atol(strToken);
						  if( tok.Next( strToken ))
						  {
                              Posit.sTheta = (short) atol(strToken);
							  m_PositArray.push_back(Posit);
						  }
					   }
				   }
			   }// end of if( tok.Next( strToken ))
               
			}// end of if( szWork[0] != '\0' )

			iCounter++;
		}while ( szWork[0] != '\0' );

		// Get paths
		iCounter = 1;
		_tcscpy( szSection, "Paths" );
		do
		{
			_stprintf(szEntry,"Path_%d", iCounter );
			GetPrivateProfileString(szSection, szEntry, "", szWork, sizeof(szWork), strPathsFile);
			if( szWork[0] != '\0' )
			{
               Path CurrentPath;
			   PATH_POSITS PathPosits;
               CTokenizer tok( szWork, _T(" ,"));
			   if( tok.Next( strToken ))
			   {
				   CurrentPath.strName = strToken;
				   PathPosits.clear();
				   while(tok.Next(strToken))
				   {
					  GoToPosition SomePosit;
					  SomePosit.lNumber = atol(strToken);
					  if( tok.Next( strToken ))
					  {
						  SomePosit.uncSpeed = 	(byte)atol(strToken);
                          PathPosits.push_back(SomePosit);
					  }// end of if( tok.Next( strToken ))
				   }// end of while(tok.Next(strToken))
				   if( PathPosits.size() > 0 )
				   {
                      CurrentPath.PositArray = PathPosits;     
                      m_PathArray.push_back(CurrentPath);
				   }
			   }// end of if( tok.Next( strToken ))

			}// end of if( szWork[0] != '\0' )

			iCounter++;  
		}while ( szWork[0] != '\0' );

		// Fill in Positions and Paths Combo boxes
        m_ComboPositNumber.ResetContent( );
		VECT_POSIT::iterator vi;
		for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
		{
			Position &Posit = *vi;
			m_ComboPositNumber.AddString(ltoa(Posit.lNumber, szWork, 10));
		}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
		OnButtonClearListPosit();
        FillInGridPositCombo();
		m_ComboPathName.ResetContent();
		VECT_PATH::iterator vp;
		for( vp = m_PathArray.begin(); vp != m_PathArray.end(); vp++ )
		{
			Path &CurrentPath = *vp;
			m_ComboPathName.AddString(CurrentPath.strName);
		}// end of for( vp = m_PathArray.begin(); vp != m_PathArray.end(); vp++ )
                         
        m_bIsPathChanged = FALSE;   
	}// end of if( strPathsFile.IsEmpty() == 0 )

}// end of void CRemotecontrolDlg::OpenPathsFile()

void CRemotecontrolDlg::OnSaveFile() 
{
	const TCHAR cszVersion[] = "1";
	TCHAR szSection[41] = "General";
	TCHAR szEntry[41];
	TCHAR szWork[1025];

	int iCounter;

    if( m_strPathFillFullName.IsEmpty() )
	{
       OnSaveAsFile();
	}
	else
	{
        _stprintf(szWork,"Intelitek %s paths file", cszApplName );

		WritePrivateProfileString(szSection, NULL, NULL, m_strPathFillFullName);
		WritePrivateProfileString(szSection, "Name", szWork, m_strPathFillFullName);
		WritePrivateProfileString(szSection, "Version", cszVersion, m_strPathFillFullName);

        _tcscpy( szSection, "Positions" );
		WritePrivateProfileString(szSection, NULL, NULL, m_strPathFillFullName);
		iCounter = 1;
		VECT_POSIT::iterator vi;
		for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
		{
			Position &Posit = *vi;
               
			_stprintf(szEntry,"Pos_%d", iCounter );
			_stprintf(szWork,"%d,%d,%d,%d", Posit.lNumber, Posit.lX, Posit.lY, Posit.sTheta );
			WritePrivateProfileString(szSection, szEntry, szWork, m_strPathFillFullName);
            iCounter++;
		}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )

        _tcscpy( szSection, "Paths" );
		WritePrivateProfileString(szSection, NULL, NULL, m_strPathFillFullName);
		iCounter = 1;
		VECT_PATH::iterator vp;
		for( vp = m_PathArray.begin(); vp != m_PathArray.end(); vp++ )
		{
			Path &CurrentPath = *vp;
			_stprintf(szEntry,"Path_%d", iCounter );
			int iCharPos = _stprintf(szWork, "%s", CurrentPath.strName );
			PATH_POSITS &Posit = CurrentPath.PositArray;
		    PATH_POSITS::iterator pai;
			for( pai = Posit.begin(); pai != Posit.end(); pai++ )
			{
               GoToPosition &SomePosit = *pai;
			   iCharPos += _stprintf(&szWork[iCharPos], ",%d,%d", SomePosit.lNumber, SomePosit.uncSpeed );
			}// end of for( pai = Posit.begin(); pai != Posit.end(); pai++ )

			WritePrivateProfileString(szSection, szEntry, szWork, m_strPathFillFullName);
            iCounter++;
		}// end of for( vp = m_PathArray.begin(); vp != m_PathArray.end(); vp++ )

        m_bIsPathChanged = FALSE;
	}

}// end of void CRemotecontrolDlg::OnSaveFile() 

BOOL CRemotecontrolDlg::GetExecDir( TCHAR *pDir )
{
   TCHAR szWork[ _MAX_PATH ];
   TCHAR modname[_MAX_PATH + 1];
   TCHAR szExeDrive[ _MAX_DRIVE ];
   TCHAR szExeDir[ _MAX_DIR ];

   if( GetModuleFileName(NULL, modname, sizeof(modname)) == 0)
   {
		return FALSE;
   }
   _tsplitpath( modname, szExeDrive, szExeDir, NULL, NULL );
   _tmakepath( szWork, szExeDrive, szExeDir, NULL, NULL ); 
   _tcscpy( pDir, szWork );
   return TRUE;
}// end of BOOL CRemotecontrolDlg::GetExecDir( TCHAR *pDir )


void CRemotecontrolDlg::OnSaveAsFile() 
{
	TCHAR szFileDialogFilter[] = "(*.apf)|*.apf||";

	CFileDialog filedialog(FALSE, _T("apf"),NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,szFileDialogFilter);
	filedialog.m_ofn.lpstrInitialDir = m_szExecDir;
	if(filedialog.DoModal() == IDOK)
	{		
        m_strPathFillFullName = filedialog.GetPathName();    
		if( m_strPathFillFullName.IsEmpty() == 0 )
			OnSaveFile();
	}// end of if(filedialog.DoModal() == IDOK)

}// end of void CRemotecontrolDlg::OnSaveAsFile() 

void CRemotecontrolDlg::OnCancel()
{

}// end of void CRemotecontrolDlg::OnCancel()

void CRemotecontrolDlg::OnExit() 
{
   SendMessage(WM_CLOSE);
}

void CRemotecontrolDlg::OnClose() 
{
   mciSendString("close Mp3 wait", "", 0, 0);

    if( m_bIsPathChanged == TRUE )
	{
		if( AfxMessageBox( "Positions and paths aren't saved. \n\nDo you want to save the information?",
						 MB_YESNO | MB_ICONERROR | MB_OK ) == IDYES )
		{
			OnSaveFile();
		}
	}// end of if( m_bIsPathChanged == TRUE )


	if( m_p_com_thread != NULL )
	{
		On_button_stop();
		m_iCloseCounter++;   	
	}

}// end of void CRemotecontrolDlg::OnClose()


void CRemotecontrolDlg::OnButtonAddPath() 
{
    CString strPathName;
	CString strPosit;
	CString strSpeed;

    GoToPosition SomeGoToPosition;
	GoToPosition LastGoToPosition;
	PATH_POSITS SomeGoToPositionArray;
	Path SomePath;

//  	UpdateData(TRUE);
	
	for( int i = 1; i < ciMaxRows; i++ )
	{
       strPosit = m_ListPosit.GetTextMatrix(i, ciColumnPosit );
	   strSpeed = m_ListPosit.GetTextMatrix(i, ciColumnSpeed );

	   SomeGoToPosition.lNumber = atol( strPosit );
       SomeGoToPosition.uncSpeed = (byte)atol( strSpeed );

	   if( SomeGoToPosition.lNumber > 0 )
	       SomeGoToPositionArray.push_back( SomeGoToPosition );

	}// end of for( i = 1; i < ciMaxRows; i++ )


    if( SomeGoToPositionArray.size() < 1 )
	{
        AfxMessageBox( "No positions in the path." ); 
		return;
	}

	m_bIsPathChanged = TRUE;
	m_ComboPathName.GetWindowText(strPathName);

	if( strPathName.IsEmpty())
	{
		SomeGoToPosition = SomeGoToPositionArray[0];
		LastGoToPosition = SomeGoToPositionArray[SomeGoToPositionArray.size() - 1];
		strPathName.Format("FROM_%d_TO_%d", SomeGoToPosition.lNumber, LastGoToPosition.lNumber );
		m_ComboPathName.SetWindowText(strPathName);
	}// end of if( strPathName.IsEmpty())
	else
	{
        if( strPathName.Find(",") >= 0 || strPathName.Find(" ") >= 0 )
		{
			AfxMessageBox( "Invalid path name." ); 
			return;
		}
	}

	SomePath.strName = strPathName;
	SomePath.PositArray = SomeGoToPositionArray;

	VECT_PATH::iterator vi;
	for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
	{
        Path &CurrentPath = *vi;
		if( CurrentPath.strName == SomePath.strName )
		{
            CurrentPath = SomePath;
			return;
		}// end of if( CurrentPath.strName == SomePath.strName )
	}// end of for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )

    m_PathArray.push_back(SomePath);

	if( m_ComboPathName.FindStringExact(-1, strPathName) == CB_ERR  )
	    m_ComboPathName.AddString(strPathName);
  	
}// end of void CRemotecontrolDlg::OnButtonAddPath() 

void CRemotecontrolDlg::OnButtonGoAlong() 
{
    CString strPathName, strWork;
	Path SomePath;

	ClearMovementFlags();
//	m_bIsGo = m_bIsTurn = m_bIsTurnTo = m_bIsGoCartes = FALSE;

	m_ComboPathName.GetWindowText(strPathName);

    if( strPathName.IsEmpty() == 0 )
	{
		VECT_PATH::iterator vi;
		for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
		{
			Path &CurrentPath = *vi;
			if( CurrentPath.strName == strPathName )
			{
				TCHAR szWork[256];
				CString strToSpeak;
				CString strVoiceFilePath;
				GetPrivateProfileString(cszVoiceSection, "GoAlong_file", "", 
									 szWork, sizeof(szWork), m_strAppLanguageFilePath);
				if( szWork[0] != '\0' )
				{
				   strVoiceFilePath = m_szExecDir + (CString)"Voice\\" + (CString)szWork;
				   PlayFile( strVoiceFilePath );
				}// end of if( szWork[0] != '\0' )
				else
				{
					GetPrivateProfileString(cszVoiceSection, "GoAlong_text", "", 
									 szWork, sizeof(szWork), m_strAppLanguageFilePath);
					if( szWork[0] != '\0' )
					{
						strToSpeak.Format(szWork, strPathName );
						strToSpeak.MakeLower();
						if( m_Speaker.GetIsSpeaking() )
							m_Speaker.StopSpeaking();
						m_Speaker.Speak(strToSpeak);   
					}
				}
				m_bIsGoCartes = FALSE;
				m_bIsGoPath = TRUE;
				CurrentPositArray = CurrentPath.PositArray;
				m_iPositCounterAlong = 0;
                m_bIsCommandFinished = TRUE;
				return;
			}// end of if( CurrentPath.strName == m_ComboPathName )
		}// end of for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
	}// end of if( strPathName.IsEmpty() != TRUE )

	strWork.Format("Invalid path name: %s", strPathName );

	if( LastReceivedString.lCommandFromDevID != 0 )
	{
		m_StaticStatus.SetWindowText(strWork);
	    AGVDriver_SendDesiredString( LastReceivedString.lCommandFromDevID, strWork );                       
	}
	else
		AfxMessageBox( strWork ); 
	return;
}// end of void CRemotecontrolDlg::OnButtonGoAlong() 

// Input:  CurrentPositArray, m_iPositCounterAlong
void CRemotecontrolDlg::GoAlongPath()
{
	GoToPosition CurPosit;
	byte uncSpeed;
	
    ClearMovementFlags();
	m_bIsGoPath = TRUE;

    if( m_bIsGoPath == TRUE && m_iPositCounterAlong < CurrentPositArray.size() )
	{
        CurPosit = CurrentPositArray[ m_iPositCounterAlong ];
		if( CurPosit.uncSpeed >= 10 )
            uncSpeed = 19;
		else
			uncSpeed = CurPosit.uncSpeed * 2;
		
		VECT_POSIT::iterator vi;
		for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
		{
			Position &Posit = *vi;
			if( Posit.lNumber == CurPosit.lNumber )
			{
				m_ListPosit.SetRow(m_iPositCounterAlong + 1 );
				GoToCartes( Posit.lX, Posit.lY, Posit.sTheta, uncSpeed );
				m_iPositCounterAlong++;
				return;
			}// end of if( Posit.lNumber == lPositNumber )
		}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
    
		AfxMessageBox( "Unknown position!" );

	}//end of if( m_bIsGoPath == TRUE && m_iPositCounterAlong < CurrentPositArray.size() )
	else
	{
        m_bIsGoPath = FALSE;	

		Speaker( "PathFinish", "" );
		
		if( LastReceivedString.lCommandFromDevID != 0)
		{    
			CString strDone( "RUN $DONE" );
            AGVDriver_SendDesiredString( LastReceivedString.lCommandFromDevID, strDone );                       
			LastReceivedString.lCommandFromDevID = 0;
		}// end of if( LastReceivedString.lCommandFromDevID != 0)
	}
}// end of void CRemotecontrolDlg::GoAlongPath()

void CRemotecontrolDlg::RepeatMoveRobot()
{
	TRACE( "Repeat Move Robot command\n" );

//	m_bWasRepeatMoveRobot = TRUE;
    GoToCartes( m_lLastXCmnd, m_lLastYCmnd, m_sLastTheta, m_uncLastSpeed );
     
//	MoveRobot( m_packet_editor_dlg_param3, m_packet_editor_dlg_param4, m_packet_editor_dlg_param5,
//		m_packet_editor_dlg_param6, m_packet_editor_dlg_param7 );

}// end of void CRemotecontrolDlg::RepeatMoveRobot()

void CRemotecontrolDlg::OnButtonDeletePath() 
{
    CString strPathName;
	Path SomePath;

	m_ComboPathName.GetWindowText(strPathName);

    if( strPathName.IsEmpty() == 0 )
	{
		VECT_PATH::iterator vi;
		for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
		{
			Path &CurrentPath = *vi;
			if( CurrentPath.strName == strPathName )
			{
				m_PathArray.erase( vi );
				int iIndex = m_ComboPathName.FindStringExact(-1, strPathName);
				if( iIndex != CB_ERR  )
					m_ComboPathName.DeleteString(iIndex);
				m_ComboPathName.SetWindowText("");     
                OnButtonClearListPosit(); 
				m_bIsPathChanged = TRUE;
				return;
			}// end of if( CurrentPath.strName == m_ComboPathName )
		}// end of for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
	}// end of if( strPathName.IsEmpty() == 0 )

    AfxMessageBox( "Invalid path name." ); 
	return;
	
}// end of void CRemotecontrolDlg::OnButtonDeletePath() 

void CRemotecontrolDlg::OnButtonClearListPosit() 
{
	for( int i = 1; i < ciMaxRows; i++ )
	{
       m_ListPosit.SetTextMatrix(i, ciColumnPosit, "" );
	   m_ListPosit.SetTextMatrix(i, ciColumnSpeed, "10" );
	}// end of for( i = 1; i < ciMaxRows; i++ )
	
}// end of void CRemotecontrolDlg::OnButtonClearListPosit() 

void CRemotecontrolDlg::OnSelchangeComboPositNumber() 
{
	CString strWork;

	int iIndex = m_ComboPositNumber.GetCurSel();
    m_ComboPositNumber.GetLBText( iIndex, strWork);
	long lPositNumber = atol(strWork);

	VECT_POSIT::iterator vi;
	for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
	{
        Position &Posit = *vi;
		if( Posit.lNumber == lPositNumber )
		{
            m_strEditX.Format("%d",Posit.lX );
            m_strEditY.Format("%d",Posit.lY );

			if( Posit.sTheta == 360 )
			{
				if( m_strEditTheta != cszANY )
				{
					m_ByUser.SetCheck( BST_UNCHECKED );
					m_Any.SetCheck( BST_CHECKED );
					OnRadioAny();
				}
			}
			else
			{
				if( m_strEditTheta == cszANY )
				{
					m_ByUser.SetCheck( BST_CHECKED );
					m_Any.SetCheck( BST_UNCHECKED );
					OnRadioByUser();
				}
                m_strEditTheta.Format("%d",Posit.sTheta );
			}
			
			UpdateData(FALSE);
			return;
		}// end of if( Posit.lNumber == lPositNumber )
	}// end of for( vi = m_PositArray.begin(); vi != m_PositArray.end(); vi++ )
	
}// end of void CRemotecontrolDlg::OnSelchangeComboPositNumber() 

void CRemotecontrolDlg::OnSelchangeComboPathName() 
{
	CString strWork;
	int iRowCounter;
	char szWork[81];

	int iIndex = m_ComboPathName.GetCurSel();
    m_ComboPathName.GetLBText( iIndex, strWork);

	VECT_PATH::iterator vi;
	for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
	{
        Path &CurrentPath = *vi;
		if( CurrentPath.strName == strWork )
		{
            PATH_POSITS &PathPosits = CurrentPath.PositArray;   
		    PATH_POSITS::iterator pai;
			iRowCounter = 1;
			OnButtonClearListPosit();
			for( pai = PathPosits.begin(); pai != PathPosits.end(); pai++ )
			{
               GoToPosition &SomePosit = *pai;
			   m_ListPosit.SetTextMatrix(iRowCounter, ciColumnPosit, ltoa(SomePosit.lNumber,szWork,10) );
			   m_ListPosit.SetTextMatrix(iRowCounter, ciColumnSpeed, ltoa(SomePosit.uncSpeed,szWork,10) );
			   iRowCounter++;
			}// end of for( pai = Posit.begin(); pai != Posit.end(); pai++ )
			return;
		}// end of if( CurrentPath.strName == SomePath.strName )
	}// end of for( vi = m_PathArray.begin(); vi != m_PathArray.end(); vi++ )
	
}// end of void CRemotecontrolDlg::OnSelchangeComboPathName()

void CRemotecontrolDlg::OnButtonHoming() 
{
#if 0
	if( m_Speaker.GetIsSpeaking() )
		m_Speaker.StopSpeaking();

    m_Speaker.Speak("Test");
#endif
#if 0
    m_bIsHoming = TRUE;

	byte byteSpeed;

	short sTurnAngle = m_sHeading;

	ClearMovementFlags();
	m_bIsTurn = TRUE;
	if( sTurnAngle > 180 )
		 sTurnAngle = -360 + sTurnAngle;
	else if( sTurnAngle < -180 )
		 sTurnAngle = 360 + sTurnAngle;

	 if( sTurnAngle < 0 )
		byteSpeed = 120;
	 else
		byteSpeed = 60;

	 m_sFirstHeading = m_sHeading;
	 m_lFirstDistanceCount = m_lDistance;

	 MoveRobot( RESEARCH_KIT_DRIVE_MOV_TURN_TYPE, byteSpeed, abs(sTurnAngle) );
#endif

#if 0
	m_iHomingHeadingCounter = 0;
	MoveRobot( RESEARCH_KIT_DRIVE_MOV_CONTOUR_TYPE, 0, 0 );
#endif
	
}// end of void CRemotecontrolDlg::OnButtonHoming() 

void CRemotecontrolDlg::OnButtonPause() 
{
	 m_bIsPause = TRUE;
}// end of void CRemotecontrolDlg::OnButtonPause()

void CRemotecontrolDlg::OnButtonContinue() 
{
    if( m_bIsGoPath == FALSE )
		return;

	if( m_bIsCommandReceived == TRUE )
	{
#ifdef _DEBUG
       m_Speaker.Speak("I did not receive completion acknowledge." );
#endif
	   m_bIsGoPath = FALSE;
	}	
             
	m_bIsPause = FALSE;
	ClearMovementFlags();

	m_bIsGoCartes = FALSE;

	m_iPositCounterAlong = m_ListPosit.GetRow() - 1;
}// end of void CRemotecontrolDlg::OnButtonContinue() 


BOOL CRemotecontrolDlg::Speaker( LPCSTR szKey, LPCSTR szDefaultText )
{
	TCHAR szWork[256];
	CString strToSpeak;

	CString strKey;
	CString strVoiceFilePath;

	GetPrivateProfileString(cszStatusSection, szKey, "", 
			         szWork, sizeof(szWork), m_strAppLanguageFilePath);

    if( szWork[0] == '\0' )
	{
       if( szDefaultText[0] != '\0' )
		   strcpy( szWork, szDefaultText );
	}
	m_StaticStatus.SetWindowText( szWork );
	if( LastReceivedString.lCommandFromDevID != 0 )
	{
		strToSpeak = szWork;
		AGVDriver_SendDesiredString( LastReceivedString.lCommandFromDevID, strToSpeak );                       
	}

    strKey = (CString)szKey + (CString)"_file";
	GetPrivateProfileString( cszVoiceSection, (char*)(LPCSTR)strKey, "", 
			         szWork, sizeof(szWork), m_strAppLanguageFilePath);

    if( szWork[0] != '\0' )
	{
       strVoiceFilePath = m_szExecDir + (CString)"Voice\\" + (CString)szWork;
	   PlayFile( strVoiceFilePath );
	}// end of if( szWork[0] != '\0' )
	else
	{
		strKey = (CString)szKey + (CString)"_text";
		GetPrivateProfileString( cszVoiceSection, (char*)(LPCSTR)strKey, "", 
						 szWork, sizeof(szWork), m_strAppLanguageFilePath);

		if( szWork[0] != '\0' )
		{
			strToSpeak = szWork;
			strToSpeak.MakeLower();
			if( m_Speaker.GetIsSpeaking() )
				m_Speaker.StopSpeaking();
			m_Speaker.Speak(strToSpeak);   
		}// end of if( szWork[0] != '\0' )
	}
	return TRUE;
   
}// end of BOOL CRemotecontrolDlg::Speaker( LPCSTR szKey, LPCSTR szDefaultText )

void CRemotecontrolDlg::OnSelchangeComboCimModes() 
{
     int iMode = GetDDMode();
	 if( iMode >= 0 )
	 {
        Daddy->cmMode = (ControlMode) iMode;

        if( Daddy->cmMode == Standalone || Daddy->cmMode == StandaloneOnly )
		{
//			pmw->SendMessage( WM_CIMDDE_INIT, 0xDDDD, 0L );
		}

		if( Daddy->cmMode == Real || Daddy->cmMode == Standalone )	
		{
		   m_Automatic.ShowWindow( SW_HIDE );
		   m_Manual.ShowWindow( SW_HIDE );
		}// end of	( Daddy->cmMode == Real || Daddy->cmMode == Standalone )
		else
		{
		   m_Automatic.ShowWindow( SW_SHOW );
		   m_Manual.ShowWindow( SW_SHOW );
           if( m_Automatic.GetCheck( ) == BST_UNCHECKED &&
			                  m_Manual.GetCheck( ) == BST_UNCHECKED )
		   {
			   m_Automatic.SetCheck( BST_CHECKED );
		   }
		   if( m_Automatic.GetCheck( ) == BST_CHECKED )
			   Daddy->cmMode = SimulAuto;
		   else
			   Daddy->cmMode = SimulManual;
		}
	 }
	 else
		 return;

}// end of void CRemotecontrolDlg::OnSelchangeComboCimModes() 

int CRemotecontrolDlg::GetDDMode()
{
	int iRet = -1;

	int iSel = m_CIM_Modes.GetCurSel( );
	switch( iSel )
	{
	   case 0:
         iRet = Real;
	   break;

       case 1:
		   if( m_Automatic.GetCheck( ) == BST_CHECKED )
            iRet = SimulAuto;
		   else
			iRet = SimulManual;
	   break;

	   case 2:
         iRet = Standalone;
	   break;

	};// end of iSel

	return iRet;
}// end of int CRemotecontrolDlg::GetDDMode()

void CRemotecontrolDlg::OnRadioAuto()
{
   OnSelchangeComboCimModes();  
}

void CRemotecontrolDlg::OnRadioManual()
{
    OnSelchangeComboCimModes();
}

int CRemotecontrolDlg::GetComboIndexOfDDModes( int iMode )
{
	int iRet = -1;

	switch( iMode )
	{
	   case Real:
		  iRet = 0;
	   break;

	   case SimulAuto: 
		  iRet = 1;
	   break;

	   case SimulManual: 
		  iRet = 1;
	   break;

	   case Standalone: 
	   case StandaloneOnly: 
		  iRet = 2;
	   break;
	};

	return iRet;
}// end of int CRemotecontrolDlg::GetComboIndexOfDDModes( int iMode )

LRESULT  CRemotecontrolDlg::AGVDriver_ReceivedString( WPARAM WParam, LPARAM LParam )
{
	char szBuf[128];
	CIMSendStringStruct t;
	const char cszRun[] = "RUN ";
	const char cszLocalize[] = "LOCALIZE ";
	const char cszStop[] = "STOP";

	long lCommandFromDevID = (long) WParam;
	if( WParam != 0xDDDD )
	{
		NDDEDataToBePassed *tempData=(NDDEDataToBePassed *)LParam;
		memcpy( &t, ( void* )&(tempData->vPOfData), sizeof t );
		//memcpy( &t, ( void* )LParam, sizeof t );
	}
#if 0
    char szWork[256];
	e_pINIFileService->GetLangString((TCHAR * )cszCIMDriverFormSect, _T("ReceivedToRun"),
		                                                     szWork, sizeof szWork);
	sprintf( szBuf, szWork, t.s );
#endif 

	sprintf( szBuf, "---> \"%s\" from Device ID: %d", t.s, lCommandFromDevID );

	SendMessage( WM_CIM_DRAWLINE, 0,(LONG)szBuf);	

    if( m_bIsRobotRespond == FALSE )
	{
		Speaker( "ControllerNotRespond", "No connection with controller" );
		return FALSE;
	}

    CString strCommmand( t.s );
        
	if( strCommmand.Find( cszRun ) == 0 )
	{
        CString strGoAlong = strCommmand.Mid(strlen(cszRun));

	    int iIndex = m_ComboPathName.FindStringExact(-1, strGoAlong);

		if( iIndex != CB_ERR )
		{
            m_ComboPathName.SetCurSel( iIndex );
			OnSelchangeComboPathName();
		}// end of if( iIndex != CB_ERR )

//        m_ComboPathName.SetWindowText(strGoAlong);        

		OnButtonGoAlong();
        if( m_bIsGoPath == TRUE )
		{
            LastReceivedString.lCommandFromDevID = lCommandFromDevID;
			LastReceivedString.strString = strCommmand;
			LastReceivedString.strPathName = strGoAlong;
		};
	}// end of if( strCommmand.Find("Run ") == 0 )
	else if( strCommmand.Find( cszLocalize ) == 0 )
	{
		CString strCoor = strCommmand.Mid(strlen(cszLocalize));

		long lX, lY;
		short sTheta;

		istrstream is( strCoor );
		lX = lY = 0;
		sTheta = 360;
		is >> lX >> lY >> sTheta;

		if( lX == 0)
		   m_lCurrentX = lX;
		else if( lX > 0 )
           m_lCurrentX = ( lX + 5 )/10;
		else if( lX < 0 )
           m_lCurrentX = ( lX - 5 )/10;


		if( lY == 0)
		   m_lCurrentY = lY;
		else if( lY > 0 )
           m_lCurrentY = ( lY + 5 )/10;
		else if( lY < 0 )
           m_lCurrentY = ( lY - 5 )/10;

		m_sPrevTheta = m_sCurrentTheta;
		m_sCurrentTheta = sTheta;

		m_sCurrentTheta = ( m_sCurrentTheta >= 0 )? m_sCurrentTheta : m_sCurrentTheta + 360; 
		m_sCurrentTheta = ( m_sCurrentTheta > 360 )? m_sCurrentTheta - 360 : m_sCurrentTheta; 

		m_sTheta_PositError = m_sCurrentTheta - m_sPrevTheta;

		ViewCartesianCoor();
	}// end of if( strCommmand.Find( cszLocalize ) == 0 )
	else if( strCommmand.Find( cszStop ) == 0 )
	{
         On_button_stop();
	}
	return 1;
}// end of LRESULT  CRemotecontrolDlg::AGVDriver_ReceivedString( WPARAM WParam, LPARAM LParam )


BOOL CRemotecontrolDlg::AGVDriver_SendDesiredString( long lToDeviceID, CString &strString )
{
	char szWorkStation[16];
	char szDDE[16];
	CIMSendStringStruct t;
	CString strToSend = strString;

	SetCurrentDirectory( Daddy->m_szHomeDir );
	if( !IsValidCIM_Address( lToDeviceID, szWorkStation, szDDE ) ) 
	{
DeviceID_Err:
		char tBuf[128];
#if 0
		e_pINIFileService->GetLangString((TCHAR * )cszCIMDriverFormSect,
			                               _T("InvalidDeviceID"), szWork, sizeof szWork);
        sprintf( tBuf, szWork, atoi( str )); 
#endif
		sprintf( tBuf, "(10) Invalid Device ID %d", lToDeviceID );
		SendMessage( WM_CIM_DRAWLINE, 0,(LONG)tBuf);
		return FALSE;
	}// end of if( !IsValidCIM_Address( lToDeviceID, szWorkStation, szDDE ) ) 
	strToSend.TrimLeft();
	strToSend.TrimRight();
	strcpy( t.s, strToSend );

	BYTE bBuffer[256];
#if 0
	e_pINIFileService->GetLangString((TCHAR * )cszCIMDriverFormSect,
			                               _T("StringWillSend"), szWork, sizeof szWork);
	sprintf( (char*)bBuffer, szWork, t.s, iDevID );
#endif

	char szBuf[80];
	if( !strcmp( szDDE, DDE_CNCITEM )) 
		sprintf( szBuf, "CNC%d", lToDeviceID );
	else if( !strcmp( szDDE, DDE_RVPITEM )) 
		sprintf( szBuf, "RVP%d", lToDeviceID );
	else if( !strcmp( szDDE, DDE_ACLITEM )) 
		sprintf( szBuf, "ACL%d", lToDeviceID );
	else if( !strcmp( szDDE, DDE_PLCITEM )) 
		sprintf( szBuf, "PLC%d", lToDeviceID );
    else
	   goto DeviceID_Err;

	NDDEDataToBePassed tempPass;
	tempPass.bIsServerPassed=1;
	memcpy(tempPass.vPOfData,&t,sizeof(t));
	tempPass.wSizeOfData=sizeof(t);
	tempPass.wWM_OfMine=WM_CIMDDE_SENDSTRING;

	if(pKnot && Daddy->cmMode != Standalone)
	{
       pKnot->SendMsg(szBuf,(void*)&tempPass,sizeof(tempPass));
	   sprintf( (char*)bBuffer, "<--- \"%s\" sent to Device ID: %d", t.s, lToDeviceID );
	   SendMessage( WM_CIM_DRAWLINE, 0,(LONG)bBuffer);
	}
		
    return TRUE;
}// end of BOOL CRemotecontrolDlg::AGVDriver_SendDesiredString( long lToDeviceID, CString &strString )


BOOL CRemotecontrolDlg::IsValidCIM_Address( int iDeviceID, char *szWorkStation,  char *szDDE )
{
	const char * const WSTATIONNAME_TEMP = "WS";
	char szBuf[MAXPATH];
	CString tempS;
	int 	tDeviceId;
	int 	tStation;
	char 	tB1[32];
	char 	tB2[32];
	char 	tCharOfDDE[8];

	szWorkStation[0] = '\0';
	szDDE[0] = '\0';


	Daddy->IniReader.GetPrivateProfileString ( 
		OPENCIMINIGENERAL, SETUPPATH, "", szBuf, sizeof( szBuf ), m_strINIfilePath );

	tempS=CString("..\\")+CString(szBuf);
	strcpy(szBuf,(LPSTR)(LPCTSTR)tempS);

	  TCHAR szFullPath[_MAX_PATH + 1] = _T("");
	  GetFullPathName( szBuf, MAX_PATH, szFullPath, NULL );

	  ifstream InData( szFullPath );

	if(!InData.is_open()) 
	   return FALSE;

	string line;
	while (getline(InData,line,'\n'))
	{
		istrstream is( line.c_str());
		tDeviceId = tStation = tB1[0] = tB2[0] = tCharOfDDE[0] = 0;
		is >> tDeviceId >> tStation >> tB1 >> tB2 >> tCharOfDDE;
		if( tDeviceId == iDeviceID && tB1[0] != 0 && tB2[0] != 0 && tCharOfDDE[0] != 0 )
		{
			sprintf( szWorkStation, "%s%d", WSTATIONNAME_TEMP, tStation  );
			_strupr( tCharOfDDE );
			switch( tCharOfDDE[0] )
				{
				case 'M': strcpy( szDDE, DDE_CNCITEM ); break;
				case 'V': strcpy( szDDE, DDE_RVPITEM ); break;
				case 'R': strcpy( szDDE, DDE_ACLITEM ); break;
				case 'C': strcpy( szDDE, DDE_PLCITEM ); break;
				default : InData.close(); return FALSE;
				}
			InData.close();
			return TRUE;
		}
	}// end of while (getline(InData,line,'\n'))
		InData.close();
	return FALSE;
}// end of BOOL CRemotecontrolDlg::IsValidCIM_Address( int iDeviceID, char *szWorkStation,  char *szDDE )

LRESULT  CRemotecontrolDlg::AGVDriver_DrawLine( WPARAM, LPARAM LParam )
{
	char *szLine = (char*)LParam;

	ListBoxAddString( (LPCSTR) szLine );

#if 0
	if( DebugProtocol )
	{
		//struct time t;
		CTime t=CTime::GetCurrentTime();
		//gettime(&t);
		char s[16];
		//sprintf( s, "%2d:%02d:%02d.%02d ", t.ti_hour, t.ti_min,
	//				t.ti_sec, t.ti_hund);
		sprintf( s, "%02d:%02d:%02d ", t.GetHour(), t.GetMinute(),
				t.GetSecond());
   
		if( OutProtocolFile.is_open() )
		{
			OutProtocolFile.write( s, strlen(s) );
			OutProtocolFile.write(szLine,strlen(szLine));
			OutProtocolFile.write("\n",1);
			OutProtocolFile.flush();
		}
	}// end of if( DebugProtocol )
#endif

#if 0
	strcpy(szWinText[nCurrLine], szLine);
	nCurrLine = (nCurrLine + 1) % MAXTEXTLINES;
	if(nLines < nWinLines) 
		nLines++;
	else 
		nFirstLine = (nFirstLine + 1) % MAXTEXTLINES;

  //if(debugger && debugger->m_b1){
	//	debugger->m_b1.AddString(szLine);
   // if(debugger->m_b1.GetCount()>100)
	//		debugger->m_b1.DeleteString(0);
	//}

	//VC::InvalidateRect( m_hWnd, NULL, TRUE );
	if(debugger2 && debugger2->m_b1.GetParent()==debugger2){
		if(strlen(szLine)>1){
			debugger2->m_b1.AddString(szLine);
			debugger2->m_b1.SetCurSel(debugger2->m_b1.GetCount()-1);
		}
	}

	UpdateWindow();  
#endif
	return 1;
}// end of LRESULT  CRemotecontrolDlg::AGVDriver_DrawLine( WPARAM, LPARAM LParam )


void CRemotecontrolDlg::ListBoxAddString( LPCSTR lpszString )
{
	CString str;
	CSize   sz;
	static int  dx=0;
	CDC*    pDC = m_CIM_Messages_List.GetDC();

	m_CIM_Messages_List.AddString( lpszString );
	int iLen = m_CIM_Messages_List.GetCount();
	if( iLen > 500 )
	{
		m_CIM_Messages_List.DeleteString(0); 
		iLen = m_CIM_Messages_List.GetCount();
	}

	m_CIM_Messages_List.SetCurSel( iLen - 1 );

    sz = pDC->GetTextExtent(lpszString);

   if (sz.cx > dx)
		  dx = sz.cx;

	m_CIM_Messages_List.ReleaseDC(pDC);

	if (m_CIM_Messages_List.GetHorizontalExtent() < dx)
	{
	   m_CIM_Messages_List.SetHorizontalExtent(dx);
	}
}// end of void CRemotecontrolDlg::ListBoxAddString( LPCSTR lpszString )

void CRemotecontrolDlg::OnRadioByUser() 
{
	((CEdit *)GetDlgItem( IDC_EDIT_THETA ))->SetReadOnly( FALSE );
    m_strEditTheta = "0";	
	UpdateData(FALSE);
}// end of void CRemotecontrolDlg::OnRadioByUser() 

void CRemotecontrolDlg::OnRadioAny() 
{
	m_strEditTheta = cszANY;
	UpdateData(FALSE);
	((CEdit *)GetDlgItem( IDC_EDIT_THETA ))->SetReadOnly( TRUE );
}// end of void CRemotecontrolDlg::OnRadioAny() 
	
BOOL CRemotecontrolDlg::PlayMP3( LPCSTR szMP3FilePath )
{
   LPTSTR lpszReturnString ="                                                                                     ";
   DWORD fdwError = 0;
   CString strMCI_Command("open ");

   char szShortPathName[_MAX_PATH];

   GetShortPathName( szMP3FilePath,szShortPathName, _MAX_PATH );

   strMCI_Command += szShortPathName;

   strMCI_Command += " type mpegvideo alias mp3";

   mciSendString("close Mp3", "", 0, 0);

//   mciSendString("open C:\\WORK\\Speech1.mp3 type mpegvideo alias mp3", "", 0, 0);
   if( mciSendString(strMCI_Command, "", 0, 0) == 0)
		 mciSendString("play mp3", "", 0, 0);

   return TRUE;
}// end of BOOL CRemotecontrolDlg::PlayMP3( LPCSTR szMP3FilePath )

BOOL CRemotecontrolDlg::PlayFile( LPCSTR szFilePath )
{
   CString strVoiceFilePath = szFilePath;
   CString strExtension = strVoiceFilePath.Right(3);
   if( strExtension.CompareNoCase("MP3")  == 0 )  
	   PlayMP3( strVoiceFilePath ); 
   else if( strExtension.CompareNoCase("WAV")  == 0 )  
	   PlaySound(strVoiceFilePath, NULL, SND_FILENAME );

	return TRUE;
}// end of BOOL CRemotecontrolDlg::PlayFile( LPCSTR szFilePath )
